package camei.select2;

import java.awt.Component;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputAdapter;
import javax.swing.event.MouseInputListener;

/**
 * }EXł̃IuWFNg̑IԊǗnhB
 * 
 * @author camei
 * @version $Id: SelectElementHandler.java,v 1.5 2006/01/31 11:13:38 camei Exp $
 */
public class SelectElementHandler extends MouseInputAdapter {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	/** ʏI */
	public static final int SIMPLE = 1;

	/** ǉI */
	public static final int ADD = 2;

	private static final int NORMAL = 11;
	private static final int PRESSED_ELEMENT = 1;
	private static final int PRESSED_SELECTION = 2;
	private static final int PRESSED_BACKGROUND = 3;
	private static final int MOVING_SELECTION = 4;
	private static final int SELECTING_BOUNDS = 5;
	private static final int ADD_PRESSED_ELEMENT = 6;
	private static final int ADD_PRESSED_SELECTION = 7;
	private static final int ADD_PRESSED_BACKGROUND = 8;
	private static final int COPYING_SELECTION = 9;
	private static final int ADD_SELECTING_BOUNDS = 10;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private SelectionManager manager;
	private int state = NORMAL;
	private int latestPressedX;
	private int latestPressedY;
	private int latestDraggedX;
	private int latestDraggedY;
	private Object latestPressedElement;

	/**
	 * RXgN^B
	 * 
	 * @param manager SelectionManager
	 */
	public SelectElementHandler(SelectionManager manager) {
		this.manager = manager;
	}

	/**
	 * ̃nhgComponentp̃nh𐶐B
	 * 
	 * @param component Component
	 * @return Componentp̃nh
	 */
	public MouseInputListener getComponentHandler(Component component) {
		return new ComponentHandler(component);
	}

	/**
	 * Componentp̃nhB<br>
	 * ComponentIuWFNg̒PʂƂĈꍇꂪ֗B
	 * 
	 * @author camei
	 * @version $Id: SelectElementHandler.java,v 1.2 2006/01/25 11:56:26 camei
	 * Exp $
	 */
	private class ComponentHandler extends MouseInputAdapter {
		private Component component;

		public ComponentHandler(Component component) {
			this.component = component;
		}

		public void mousePressed(MouseEvent e) {
			Rectangle bounds = component.getBounds();
			int option = manager.getSelectOption(e);
			pressed(e.getX() + bounds.x, e.getY() + bounds.y, component, option);
		}

		public void mouseReleased(MouseEvent e) {
			released();
		}

		public void mouseDragged(MouseEvent e) {
			Rectangle bounds = component.getBounds();
			dragged(e.getX() + bounds.x, e.getY() + bounds.y);
		}
	}

	/***************************************************************************
	 * MouseInputAdapter ̎
	 **************************************************************************/
	/**
	 * }EX̏B
	 * 
	 * @param e MouseEvent
	 */
	public void mousePressed(MouseEvent e) {

		Point point = manager.getGlobalPoint(e);
		int x = (int) point.getX();
		int y = (int) point.getY();
		Object element = manager.getElement(e);
		int option = manager.getSelectOption(e);

		pressed(x, y, element, option);
	}

	public void pressed(int x, int y, Object element, int option) {
		if (state == NORMAL) {
			boolean isSelected = manager.isSelected(element);
			if (option == SIMPLE) {// ʏ|Cg@
				if (element != null && !isSelected) {// Ivf|Cg
					// vfI
					manager.clearSelection();
					manager.select(element);
					state = PRESSED_ELEMENT;
				} else if (element != null && isSelected) {// Ivf|Cg
					state = PRESSED_SELECTION;
				} else if (element == null) {// wi|Cg
					// I
					manager.clearSelection();
					state = PRESSED_BACKGROUND;
				}
			} else if (option == ADD) {// ǉ|Cg@
				if (element != null && !isSelected) {// Ivf|Cg
					// vfI
					manager.select(element);
					state = ADD_PRESSED_ELEMENT;
				} else if (element != null && isSelected) {// Ivf|Cg
					state = ADD_PRESSED_SELECTION;
				} else if (element == null) {// wi|Cg
					state = ADD_PRESSED_BACKGROUND;
				}
			}
		}
		latestPressedX = x;
		latestPressedY = y;
		latestDraggedX = x;
		latestDraggedY = y;
		latestPressedElement = element;
	}

	/**
	 * }EX̏B
	 * 
	 * @param e MouseEvent
	 */
	public void mouseReleased(MouseEvent e) {
		released();
	}

	/**
	 * }EX̏B
	 */
	public void released() {
		if (state == PRESSED_ELEMENT) {
			state = NORMAL;
		} else if (state == PRESSED_SELECTION) {
			state = NORMAL;
			manager.edit(latestPressedElement);
		} else if (state == PRESSED_BACKGROUND) {
			state = NORMAL;
		} else if (state == MOVING_SELECTION) {
			manager.decideMoveSelection();
			state = NORMAL;
		} else if (state == SELECTING_BOUNDS) {
			manager.decideSelectBoudns();
			state = NORMAL;

		} else if (state == ADD_PRESSED_ELEMENT) {
			state = NORMAL;
		} else if (state == ADD_PRESSED_SELECTION) {
			manager.unselect(latestPressedElement);// IvfO
			state = NORMAL;
		} else if (state == COPYING_SELECTION) {
			manager.decideCopySelection();// I͈͂Rs[̊m
			state = NORMAL;
		} else if (state == ADD_SELECTING_BOUNDS) {
			manager.decideSelectBoudns();// `͈͂I̊m
			state = NORMAL;
		}
	}

	/**
	 * }EXhbȌB
	 * 
	 * @param e MouseEvent
	 */
	public void mouseDragged(MouseEvent e) {
		Point point = manager.getGlobalPoint(e);
		int x = (int) point.getX();
		int y = (int) point.getY();

		dragged(x, y);
	}

	/**
	 * }EXhbȌB
	 * 
	 * @param x }EX̍Wx
	 * @param y }EX̍Wy
	 */
	public void dragged(int x, int y) {
		int dx = x - latestDraggedX;
		int dy = y - latestDraggedY;

		if (state == PRESSED_ELEMENT) {
			manager.readyMoveSelection();// I͈͂ړ̏
			manager.moveSelection(dx, dy);// I͈͂ړ
			state = MOVING_SELECTION;
		} else if (state == PRESSED_SELECTION) {
			manager.readyMoveSelection();// I͈͂ړ̏
			manager.moveSelection(dx, dy);// I͈͂ړ
			state = MOVING_SELECTION;
		} else if (state == MOVING_SELECTION) {
			manager.moveSelection(dx, dy);// I͈͂ړ
		} else if (state == PRESSED_BACKGROUND) {
			manager.readySelectBounds();// `͈͂Ȉ
			manager.selectBounds(latestPressedX, latestPressedY, x, y);// `͈͂I
			state = SELECTING_BOUNDS;
		} else if (state == SELECTING_BOUNDS) {
			manager.selectBounds(latestPressedX, latestPressedY, x, y);// `͈͂I

		} else if (state == ADD_PRESSED_ELEMENT) {
			manager.readyCopySelection();// I͈͂Rs[̏
			manager.copySelection(dx, dy);// I͈͂Rs[
			state = COPYING_SELECTION;
		} else if (state == ADD_PRESSED_SELECTION) {
			manager.readyCopySelection();// I͈͂Rs[̏
			manager.copySelection(dx, dy);// I͈͂Rs[
			state = COPYING_SELECTION;
		} else if (state == COPYING_SELECTION) {
			manager.copySelection(dx, dy);// I͈͂Rs[
		} else if (state == ADD_PRESSED_BACKGROUND) {
			// `̈ǉI
			manager.readySelectBoundsAdditional();// `͈͂ǉȈ
			manager
					.selectBoundsAdditional(latestPressedX, latestPressedY, x,
							y);// `͈͂ǉI
			state = ADD_SELECTING_BOUNDS;
		} else if (state == ADD_SELECTING_BOUNDS) {
			// `̈ǉI
			manager
					.selectBoundsAdditional(latestPressedX, latestPressedY, x,
							y);// `͈͂ǉI
			state = ADD_SELECTING_BOUNDS;
		}
		latestDraggedX = x;
		latestDraggedY = y;
	}

	/***************************************************************************
	 * Getter
	 **************************************************************************/

	/**
	 * @return ǉI`̈ĂԂ
	 */
	public boolean isAddSelectingBounds() {
		return state == ADD_SELECTING_BOUNDS;
	}

	/**
	 * @return I`̈ĂԂ
	 */
	public boolean isSelectingBounds() {
		return state == SELECTING_BOUNDS;
	}

	/**
	 * @return Ō̃hbŐ
	 */
	public Point getLatestDragDistance() {
		int dx = latestDraggedX - latestPressedX;
		int dy = latestDraggedY - latestPressedY;
		
		return new Point(dx,dy);
	}

}
