/*
 * Created on 2006/02/08
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package camei.undo;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.StateEdit;
import javax.swing.undo.StateEditable;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEdit;

/**
 * UndoManager̃X^bN̓׋邽߂̏GB<br>
 * ESignificant  StateEditƂ͂ȂɂH<br>
 * ExUndoɑ΂Ăǂ܂Undô<bR>
 * Class UndoSample
 *
 * @author camei
 * @version $Id: UndoSample.java,v 1.1 2006/02/08 17:18:15 camei Exp $
 */
public class UndoSample extends JFrame implements UndoableEditListener {

	private UndoManager undoManager = new UndoManager() {
		public boolean addEdit(UndoableEdit anEdit) {
			boolean result = super.addEdit(anEdit);
			showUndoStack();
			return result;
		}

		public void undo() {
			super.undo();
			showUndoStack();
		}

		public void redo() {
			super.redo();
			showUndoStack();
		}

		private void showUndoStack() {
			StringBuffer stack = new StringBuffer("<html>");
			List editList = new ArrayList(this.edits);
			for (Iterator i = editList.iterator(); i.hasNext();) {
				UndoableEdit edit = (UndoableEdit) i.next();
				String significant = edit.isSignificant() ? "" : "~";
				String undoneOrRedone = edit.canUndo() ? "<font color=\"red\">"
						: "<font color=\"blue\">";
				stack.append(undoneOrRedone + significant + "</font>");
			}
			undoStack.setText(stack.toString());
		}
	};
	private JLabel status = new JLabel();
	private JLabel undoStack = new JLabel();

	public UndoSample() {
		super("Undo ̋Zp");

		JTextPane editor = new JTextPane();

		// GfB^̏
		editor.getDocument().addUndoableEditListener(this);

		// {^pl̏
		JPanel toolPanel = new JPanel();
		{
			JButton undo = new JButton();
			undo.setAction(new AbstractAction() {

				public void actionPerformed(ActionEvent e) {
					System.out.println("#actionPerformed:");
					System.out.println("source=" + e.getSource());
					if (undoManager.canUndo()) {
						undoManager.undo();
						updateUndoStatus();
					}
				}
			});
			undo.setLabel("Undo");

			JButton redo = new JButton();
			redo.setAction(new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					System.out.println("#actionPerformed:");
					System.out.println("source=" + e.getSource());
					if (undoManager.canRedo()) {
						undoManager.redo();
						updateUndoStatus();
					}
				}
			});
			redo.setLabel("Redo");

			JButton stateEdit = new JButton(new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					undoManager
							.addEdit(new StateEdit(new StateEditSample(), "??"));
				}
			});
			stateEdit.setLabel("StateEdit");

			JButton notSignificant = new JButton(new AbstractAction() {
				public void actionPerformed(ActionEvent e) {
					undoManager.addEdit(new AbstractUndoableEdit() {
						public boolean isSignificant() {
							return false;
						}
					});
				}
			});
			notSignificant.setLabel("not Significant edit");

			toolPanel.add(undo);
			toolPanel.add(redo);
			toolPanel.add(stateEdit);
			toolPanel.add(notSignificant);
		}

		JPanel undoPanel = new JPanel();
		undoPanel.setLayout(new BorderLayout());
		undoPanel.add(undoStack, BorderLayout.NORTH);
		undoPanel.add(status, BorderLayout.SOUTH);

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		contentPane.add(toolPanel, BorderLayout.NORTH);
		contentPane.add(editor, BorderLayout.CENTER);
		contentPane.add(undoPanel, BorderLayout.SOUTH);

		setBounds(100, 60, 400, 400);
		setVisible(true);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new UndoSample();
	}

	public void undoableEditHappened(UndoableEditEvent e) {
		System.out.println("udnoableEditHappened:" + e.getEdit());

		// UndoX^bNUndoableEdit
		undoManager.addEdit(e.getEdit());
		updateUndoStatus();

	}

	/*
	 * Undo Redo ԕ\̍XV
	 */
	private void updateUndoStatus() {
		String undoInfo = "Undo:" + undoManager.getUndoPresentationName()
				+ ",Redo:" + undoManager.getRedoPresentationName();
		status.setText(undoInfo);
	}

	private class StateEditSample implements StateEditable{

		public void restoreState(Hashtable state) {
			System.out.println("restoreState");
		}

		public void storeState(Hashtable state) {
			System.out.println("storeState");
		}
		
	}
}
