/*
 * Created on Jun 30, 2005 Copyright (c) 2005 Nooto Poject. All rights reserved.
 */
package note;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.util.logging.Level;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.WindowConstants;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.UndoManager;

import note.command.AbstractCommand;
import note.command.AnchorMoveCommand;
import note.configuration.ApplicationConfiguration;
import note.control.KeyCommandMap;
import note.control.NoteApplicationMode;
import note.control.NoteMenuBar;
import note.control.Pen;
import note.control.GUI.SaveConfirmDialog;
import note.model.Note;
import note.viewer.NoteProcessorPane;

import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

/**
 * Class NoteApplication ûƁṽCNX
 * 
 * @author camei
 * @version $Id: NoteApplication.java,v 1.48 2006/02/07 13:23:43 hashiyaman Exp $
 */
public class NoteApplication extends JFrame implements MouseListener,
		MouseMotionListener, KeyListener, UndoableEditListener {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	public static final String VERSION = "̂ ver. 0.99";
	public static final String URL = "http://note.crew.sfc.keio.ac.jp/";
	public static final String COPYRIGHT = "Copyright (C) 2005-2006 by ̂ƃvWFNg";
	public static final String DEVELOPERS = "Atsushi Sato, Takumi Fujita, Makito Hashiyama";

	// EChȄʒuATCY
	private static final int WINDOW_X = 100;
	private static final int WINDOW_Y = 40;
	private static final int WINDOW_WIDTH = 800;
	private static final int WINDOW_HEIGHT = 600;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private Note note;// NoteNXPageNXɎQƂł悤ɂB
	private ApplicationConfiguration configuration;// AvP[V̐ݒ

	// GUIi
	// private JLabel status; // Xe[^Xo[
	private SaveConfirmDialog dialog; // ۑmF_CAO
	// private JComponent editWindow;// ҏWEChE
	private NoteProcessorPane noteProcessorPane;
	private FunctionPanel functionPanel;

	private String directoryPath;// fBNgpXi㏑ۑꏊj

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 */
	public NoteApplication() {
	}

	/**
	 * AvP[VJn
	 */
	public void start() {
		NoteLogger.log(Level.INFO, "̂ƋN");

		// NS\
		NoteSplashWindow logo = new NoteSplashWindow();
		logo.splash();

		// ݒ
		this.configuration = new ApplicationConfiguration(this);

		// VKm[gݒ肷
		setNote(new Note());

		// GUIݒ肷
		setupGUI();

		// EBhE\B
		this.setVisible(true);

		// NS
		logo.close();
	}

	/**
	 * note ݒ肷B
	 * 
	 * @param note m[g
	 */
	public void setNote(Note note) {
		// Modelւ
		this.note = note;

		// Viewւ
		{// ҏWyCւ
			// łɕҏWyC΍폜
			if (noteProcessorPane != null) {
				getContentPane().remove(noteProcessorPane);
			}

			// VҏWyC\t
			noteProcessorPane = new NoteProcessorPane(note, configuration, this);
			getContentPane().add(noteProcessorPane, BorderLayout.CENTER);

			// EChE\XV
			getContentPane().validate();
			getContentPane().repaint();
		}

		// ۑmF_CAOpӂ
		dialog = new SaveConfirmDialog();

	}

	/**
	 * EChE𐶐
	 */
	public void setupGUI() {
		// t@Cݒ肷
		this.setTitle(noteProcessorPane.getFileName());
		// status = new JLabel("");

		{// j[o[
			// j[o[
			JMenuBar menuBar = new NoteMenuBar(this, configuration
					.getKeyConfiguration());
			this.setJMenuBar(menuBar);
		}

		{// 㕔̃pl\ TODO 
			// y̏
			// JLabel penParam = new JLabel(configuration.getCurrentPen());
			// penParam.setPreferredSize(new Dimension(40, 40));
			// penParam.addKeyListener(this);
			//
			// // {^plɂ̂ăEChEɓ\
			// JPanel panel = new JPanel();
			// // panel.add(penParam);
			// panel.addKeyListener(this);// tH[JXDꂽ̑Ώ
			// this.getContentPane().add(panel, BorderLayout.NORTH);
		}

		{// t@NVpl\
			// t@NV{^ǉ
			JPanel southPanel = new JPanel();
			southPanel.setLayout(new GridLayout(2, 1));
			functionPanel = new FunctionPanel(this);
			// TODO 蓖ĂĂR}hɂĕ\ւ悤ɂ
			functionPanel.setFunctionName(1, "F1 ");
			functionPanel.setFunctionName(2, "F2 G");
			functionPanel.setFunctionName(3, "F3 Ł");
			functionPanel.setFunctionName(4, "F4 Ł");
			functionPanel.setFunctionName(5, "F5 ");
			functionPanel.setFunctionName(6, "F6 ");
			functionPanel.setFunctionName(7, "F7 ");
			functionPanel.setFunctionName(8, "F8 ");
			functionPanel.setFunctionName(9, "F9 ");
			functionPanel.setFunctionName(10, "F10 ");
			functionPanel.setFunctionName(11, "F11 ");
			functionPanel.setFunctionName(12, "F12 __");
			southPanel.add(functionPanel);
			this.getContentPane().add(southPanel, BorderLayout.SOUTH);

			// Xe[^Xo[ݒ肵ăEChEɓ\
			// TODO ƂXe[^Xo[
			// southPanel.add(status);
		}

		/*
		 * EBhE(~{^)ɁA vOI悤ɁACxgXi[ݒB
		 * EChEANeBuɂȂƂ̋ݒB
		 */
		this.addWindowListener(new WindowAdapter() {
			// EChEI
			public void windowClosing(WindowEvent e) {
				confirmSave(true);
			}

			// EChEJy[WɃtH[JX𓖂Ă
			public void windowOpened(WindowEvent e) {
				noteProcessorPane.getCurrentPagePane().getViewer()
						.requestFocus();
				// note.getCurrentPage().requestFocus();
			}

			/*
			 * EChEANeBuɂȂƂɃy[WɃtH[JXڂB
			 * 
			 * @see java.awt.event.WindowAdapter#windowActivated(java.awt.event.WindowEvent)
			 */
			public void windowActivated(WindowEvent e) {
				noteProcessorPane.getCurrentPagePane().getViewer()
						.requestFocus();
				System.out
						.println(getClass().getName() + ":focus > PageViewer");
			}

		});

		// EChËʒuƕWTCYw肷
		setBounds(WINDOW_X, WINDOW_Y, WINDOW_WIDTH, WINDOW_HEIGHT);

		// EBhȆ傫𒲂ׂĕ\BTODO 
		// Dimension frameSize = this.getSize();
		// System.out.println("Window size: width " + frameSize.width + " height
		// "
		// + frameSize.height);

		// y[WɃtH[JXĂ
		// TODO Ȃ̂łȂB
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				noteProcessorPane.getCurrentPagePane().getViewer()
						.requestFocus();
				// note.getCurrentPage().requestFocus();
			}
		});

		// L&Fwindowsɐݒ肷
		try {
			UIManager.setLookAndFeel(WindowsLookAndFeel.class.getName());
			SwingUtilities.updateComponentTreeUI(this);
		} catch (ClassNotFoundException e1) {
			e1.printStackTrace();
		} catch (InstantiationException e1) {
			e1.printStackTrace();
		} catch (IllegalAccessException e1) {
			e1.printStackTrace();
		} catch (UnsupportedLookAndFeelException e1) {
			e1.printStackTrace();
		}
	}

	/**
	 * R}hCsB
	 * 
	 * @param args R}hC
	 */
	public static void main(String[] args) {
		NoteApplication noteApplication = new NoteApplication();
		noteApplication.start();
	}

	/**
	 * ĕ`悷
	 */
	public void repaint() {
		// Xe[^Xo[Ƀ[h̏Ԃ\
		// status.setText(note.getCurrentPage().getMode().paramString());

		// ĕ`悷
		super.repaint();
	}

	/**
	 * R}hsB<br>
	 * R}hUndo}l[W[ɐςłsꍇ͂̃\bhgƁB
	 * 
	 * @param command sR}h
	 */
	public boolean executeCommand(AbstractCommand command) {
		// R}hs
		if (command != null) {
			// R}h̃Rs[
			AbstractCommand cloneCommand = (AbstractCommand) command.clone();

			if (cloneCommand.canExecute()) {// s\ȏꍇ
				// Rs[s
				cloneCommand.execute();

				// Rs[UndoManagerɐς
				if (cloneCommand.isUndoableEdit()) {// \̏ꍇ
					UndoManager undoManager = noteProcessorPane
							.getUndoManager();
					undoManager.addEdit(cloneCommand);
					noteProcessorPane.setDirty(true);
					setTitle("*" + noteProcessorPane.getFileName());
				}

				NoteLogger.log(Level.INFO, "R}hF" + cloneCommand);
				return true;
			}
		}
		return false;
	}

	/**
	 * ύXۑ邩mF
	 * 
	 * @param isQuit ItrueCۑfalse
	 */
	public void confirmSave(boolean isQuit) {
		String action = null;
		if (noteProcessorPane.isDirty()) {// ύXĂꍇ
			action = dialog.showDialog();

			// ꂽ{^ɂďς
			if (action != null) {
				if (action.equals("yes")) {
					saveAs();
					if (isQuit) {
						quit();
					} else {
						open();
					}
				} else if (action.equals("no")) {
					if (isQuit) {
						quit();
					} else {
						open();
					}
				} else if (action.equals("cancel")) {
					// EBhEɁCp
					setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				}
			}
		} else {// ύXĂȂꍇ
			quit();
		}
	}

	/*
	 * I
	 */
	private void quit() {
		System.out.println("IJn");

		// L[ݒۑ
		configuration.getKeyConfiguration().save();

		System.out.println("I");
		// I
		System.exit(0);
	}

	/***************************************************************************
	 * ۑCǍ
	 **************************************************************************/
	/**
	 * ̂Ƃʖۑ
	 */
	public void saveAs() {
		// t@C`[ŨZNV
		JFileChooser file = new JFileChooser();
		int selected = file.showSaveDialog(this);

		if (selected == JFileChooser.APPROVE_OPTION) {// ۑ{^ꂽȂ
			directoryPath = file.getCurrentDirectory() + "\\"
					+ file.getSelectedFile().getName();// ۑꏊ̐ݒ
			save(directoryPath);
		}
	}

	/**
	 * ̂Ƃۑi㏑ۑj
	 */
	public void save(String directoryPath) {
		// ̂Ƃ̃t@CύX
		String[] fileName = directoryPath.split("\\\\");
		noteProcessorPane.setFileName(fileName[fileName.length - 1]);
		setTitle(noteProcessorPane.getFileName());

		try {
			ObjectOutput out = new ObjectOutputStream(new FileOutputStream(
					directoryPath));
			out.writeObject(note);// ̂Ƃ̕ۑ

			out.flush();
			out.close();

			System.out.println(directoryPath + "ɕۑ܂");

			noteProcessorPane.setDirty(false);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * ̂ƂJ
	 */
	public void readyToOpen() {
		// t@CύXĂCύXۑmF
		if (noteProcessorPane.isDirty()) {
			confirmSave(false);
		} else {
			open();
		}
	}

	/**
	 * ̂ƂJ
	 */
	public void open() {
		JFileChooser file = new JFileChooser();
		int selected = file.showOpenDialog(this);

		if (selected == JFileChooser.APPROVE_OPTION) {// J{^ꂽȂ
			String newNoteName = file.getCurrentDirectory() + "\\"
					+ file.getSelectedFile().getName();// Jt@C̐ݒ
			directoryPath = newNoteName;// fBNgpXۑ

			// ǂݍ݂̃ZNV
			try {
				ObjectInputStream in = new ObjectInputStream(
						new FileInputStream(newNoteName));
				Note newNote = (Note) in.readObject();// IIuWFNĝƂƂĊJ
				this.setNote(newNote);// VnoteZbgB

				in.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}

			noteProcessorPane.setFileName(file.getSelectedFile().getName());// t@C擾
			setTitle(noteProcessorPane.getFileName());// t@Cݒ肷
			System.out.println("Jt@CF" + noteProcessorPane.getFileName());

			repaint();
		}
	}

	// private void readObject(ObjectInputStream stream) throws IOException {
	// try {
	// stream.defaultReadObject();
	//			
	// } catch (IOException e) {
	// // TODO ꂽ catch ubN
	// e.printStackTrace();
	// } catch (ClassNotFoundException e) {
	// // TODO ꂽ catch ubN
	// e.printStackTrace();
	// }
	// }

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/**
	 * ɖ߂B<br>
	 * Undo
	 */
	public void undo() {
		UndoManager undoManager = noteProcessorPane.getUndoManager();
		if (undoManager.canUndo()) {
			NoteLogger.log(Level.INFO, "Undo:"
					+ undoManager.getUndoPresentationName());
			undoManager.undo();
		}
	}

	/**
	 * 蒼B<br>
	 * Redo
	 */
	public void redo() {
		UndoManager undoManager = noteProcessorPane.getUndoManager();
		if (undoManager.canRedo()) {
			NoteLogger.log(Level.INFO, "Redo:"
					+ undoManager.getRedoPresentationName());
			undoManager.redo();
		}
	}

	public String getUndoPresentationName() {
		UndoManager undoManager = noteProcessorPane.getUndoManager();
		return undoManager.getUndoPresentationName();
	}

	public String getRedoPresentationName() {
		UndoManager undoManager = noteProcessorPane.getUndoManager();
		return undoManager.getRedoPresentationName();
	}

	public boolean canRedo() {
		return noteProcessorPane.getUndoManager().canRedo();
	}

	public boolean canUndo() {
		return noteProcessorPane.getUndoManager().canUndo();
	}

	/***************************************************************************
	 * UndoableEditListener ̎
	 **************************************************************************/
	/**
	 * \ȕҏWNƂ̏B<br>
	 * 
	 * @param e UndoableEditEvent
	 * @see javax.swing.event.UndoableEditListener#undoableEditHappened(javax.swing.event.UndoableEditEvent)
	 */
	public void undoableEditHappened(UndoableEditEvent e) {
		// Undo}l[W[UndoableEditς
		UndoManager undoManager = noteProcessorPane.getUndoManager();
		undoManager.addEdit(e.getEdit());
		noteProcessorPane.setDirty(true);
	}

	/***************************************************************************
	 * }EX
	 **************************************************************************/

	/**
	 * }EX{^ꍇ̑B<br>
	 * ړCL[ƂɑΉĂ
	 */
	public void mousePressed(MouseEvent e) {
	}

	/**
	 * }EX{^𗣂ꍇ̑B<br>
	 * ړCL[𗣂ƂɑΉĂ
	 */
	public void mouseReleased(MouseEvent e) {
	}

	/**
	 * }EXhbOꍇ̑B<br>
	 * ړCqL[ȂړL[ƂɑΉĂ
	 */
	public void mouseDragged(MouseEvent e) {
	}

	/*
	 * AJ[ΈʒuɈړB
	 */
	private void moveAnchorAbsolutely(int x, int y) {
		executeCommand(new AnchorMoveCommand(AnchorMoveCommand.ABSOLUTE, x, y,
				this));
	}

	// gȂ}EX\bh
	public void mouseMoved(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	/**
	 * }EXNbN̏B
	 * 
	 * @param e MouseEvent
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
	}

	/***************************************************************************
	 * L[{[h
	 **************************************************************************/
	/**
	 * L[ꂽ̑B
	 */
	public void keyPressed(KeyEvent e) {
		executeCommandByKey(e);
	}

	/**
	 * L[ꂽƂ̑B
	 */
	public void keyReleased(KeyEvent e) {
		executeCommandByKey(e);
	}

	/**
	 * L[^CvꂽƂ̑B
	 */
	public void keyTyped(KeyEvent e) {
		executeCommandByKey(e);
	}

	/**
	 * t@NVL[ꂽƂ̑B
	 */
	public void executeFunction(int keyCode, int modifiers) {
		System.out.println(keyCode + "," + modifiers);
		KeyCommandMap functionKeyMap = configuration.getKeyConfiguration()
				.getFunctionKeyMap();
		if (functionKeyMap.containsKey(keyCode, modifiers)) { // t@NVL[ɋ@\o^Ă
			AbstractCommand command = functionKeyMap.getCommand(keyCode,
					modifiers);
			executeCommand(command);
		}
	}

	/*
	 * L[CxgɑΉR}hsB
	 */
	private void executeCommandByKey(KeyEvent e) {
		// ΉR}h擾
		NoteApplicationMode mode = note.getCurrentPage().getMode();
		AbstractCommand command = configuration.getKeyConfiguration()
				.getCommand(mode, e);

		// R}hs
		if (executeCommand(command)) {// R}hsꍇ
			// L[Cxg
			e.consume();
		}
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return note ߂B
	 */
	public Note getNote() {
		return note;
	}

	/**
	 * @return noteProcessorPane ߂B
	 */
	public NoteProcessorPane getNoteProcessorPane() {
		return noteProcessorPane;
	}

	/**
	 * @return ݂̃y߂B
	 */
	public Pen getPen() {
		return configuration.getCurrentPen();
	}

	/**
	 * @return o^Ă}`̃}bv߂B
	 */
	public RegisteredPictureMap getRegisteredPictures() {
		return configuration.getRegisteredPictures();
	}

	/**
	 * @return t@C̕ۑꏊ߂
	 */
	public String getDirectoryPath() {
		return directoryPath;
	}
}
