package note.command;

import java.awt.Point;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoableEdit;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.Group;
import note.model.Page;
import note.model.PictureGroup;
import note.model.TextGroup;
import note.model.picture.PicturePoint;
import note.viewer.PictureGroupPane;

/**
 * AJ[ړR}hB<br>
 * TODO ̃R}h͏ԂɂāAقȂ铮ĂB xĂ݂Ă݂΁ÃR}hsĂB
 * ꂼR}hƂēƗ鎖ɂāA₷Ȃ͂B
 */
public class AnchorMoveCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	// ړ@
	public static final int ABSOLUTE = 1;
	public static final int RELATIVE = 2;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int type = RELATIVE;
	private int dx = 0;// xړ
	private int dy = 0;// yړ

	// Undo
	private NoteApplicationMode oldMode = null;
	private TextGroup fixedTextGroup = null;
	private TextGroup createdTextGroup = null;
	private TextGroup movedTextGroup = null;
	private PictureGroupPane edittedPictureGroupEditor = null;
	private PicturePoint oldFocusPoint = null;
	private int oldX;// ړÕAJ[ʒu
	private int oldY;
	private int toX;// ړ̃AJ[ʒu
	private int toY;
	private boolean isEdittingMoved = false;// }`ό`
	private boolean isSimpleMoved = false;
	private boolean isFixedAndMoved = false;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 * 
	 * @param type ړ@
	 * @param dx xړʁA܂xW
	 * @param dy yړʁA܂yW
	 * @param reciever V[o[
	 */
	public AnchorMoveCommand(int type, int dx, int dy, NoteApplication reciever) {
		super(reciever);

		this.type = type;
		this.dx = dx;
		this.dy = dy;
	}

	/**
	 * @return N[߂B
	 * @see note.command.AbstractCommand#clone()
	 */
	public Object clone() {
		AnchorMoveCommand clone = new AnchorMoveCommand(type, dx, dy,
				getApplication());
		return clone;
	}

	/**
	 * @return ݎs\
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return true;
	}

	/**
	 * sB
	 * 
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		int x;
		int y;

		{// ړ̍WvZ
			Point point = (Point) (getCurrentPage().getAnchorPoint());
			oldX = (int) point.getX();
			oldY = (int) point.getY();

			if (type == ABSOLUTE) {
				x = this.dx;
				y = this.dy;
			} else if (type == RELATIVE) {
				x = (int) point.getX() + dx;
				y = (int) point.getY() + dy;
			} else {
				throw new RuntimeException("type̎w肪sł");
			}
		}

		// ړ
		moveAnchor(x, y);
	}

	/*
	 * w肵WɃAJ[ړ
	 */
	private void moveAnchor(int x, int y) {
		NoteApplicationMode mode = getMode();
		oldMode = (NoteApplicationMode) mode.clone();
		Page currentPage = getCurrentPage();

		if (mode.isPictureMode()) {// }`̓[h̏ꍇ

			if (mode.isWaitInputting()) {// ͑҂̏ꍇ
				// AJ[ړ
				currentPage.setAnchorLocation(x, y);

				isSimpleMoved = true;// Undo̕ۑ
				toX = x;// Undo̕ۑ
				toY = y;// Undo̕ۑ

			} else if (mode.isInputting()) {// ͒̏ꍇ

				// I_ҏWړ
				edittedPictureGroupEditor = (PictureGroupPane) getEditableGroupEditor();
				oldFocusPoint = edittedPictureGroupEditor.getFocusPoint();// Undo̕ۑ
				edittedPictureGroupEditor.edittingMoveByFocusPoint(x, y);

				// ړ̑I_̈ʒuɃAJ[ړ
				Group group = edittedPictureGroupEditor.getGroup();
				PicturePoint movedFocusPoint = edittedPictureGroupEditor.getFocusPoint();
				toX = (int) (group.getX() + movedFocusPoint.getX());// Undo̕ۑ
				toY = (int) (group.getY() + movedFocusPoint.getY());// Undo̕ۑ

				isEdittingMoved = true;// Undo̕ۑ
			}

		} else if (mode.isTextMode()) {// eLXg̓[h̏ꍇ

			if (mode.isInputting()) {// ͒̏ꍇ
				// O[vm
				fixedTextGroup = getEdittingTextGroup();// Undo̕ۑ
				fixedTextGroup.getEditor().setEditable(false);

				// VKeLXgO[v쐬
				createdTextGroup = createTextGroup();// Undo̕ۑ

				// AJ[ړ
				currentPage.setAnchorLocation(x, y);

				// ̃eLXgO[vړ
				movedTextGroup = getEdittingTextGroup();// Undo̕ۑ
				movedTextGroup.setLocation(x, y);

				isFixedAndMoved = true;// Undo̕ۑ
				toX = x;// Undo̕ۑ
				toY = y;// Undo̕ۑ

			} else if (mode.isWaitInputting()) {// ͑҂̏ꍇ
				// AJ[ړ
				currentPage.setAnchorLocation(x, y);

				// ̃eLXgO[vړ
				movedTextGroup = getEdittingTextGroup();// Undo̕ۑ
				movedTextGroup.setLocation(x, y);

				isSimpleMoved = true;
				toX = x;// Undo̕ۑ
				toY = y;// Undo̕ۑ
			}
		}

		// AJ[ړʒm
		mode.anchorMoved();

		repaint();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// \
		return true;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		if (isEdittingMoved) {
			return "}`ό`";
		} else {
			if (fixedTextGroup != null) {
				return "eLXgO[vm,AJ[ړ";
			} else {
				return "AJ[ړ";
			}
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#addEdit(javax.swing.undo.UndoableEdit)
	 */
	public boolean addEdit(UndoableEdit anEdit) {
		if (anEdit instanceof AnchorMoveCommand) {
			// AJ[ړR}h
			AnchorMoveCommand command = (AnchorMoveCommand) anEdit;

			if (isSimpleMoved && command.isSimpleMoved) {// PȈړJԂƂ
				// TODO ̏ꍇ͂̂HׂďB
				toX = command.toX;
				toY = command.toY;
				return true;

			} else if (isEdittingMoved && command.isEdittingMoved
					&& oldFocusPoint == command.oldFocusPoint) {// I_ҏWړꍇ
				toX = command.toX;
				toY = command.toY;
				return true;

			} else if (isFixedAndMoved && command.isSimpleMoved) {// m肵ƈړ𑱂Ăꍇ
				toX = command.toX;
				toY = command.toY;
				return true;
			}
		}
		return false;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();

		Page currentPage = getCurrentPage();

		// AJ[ʒu̍ŏIIȈʒuɈړ
		currentPage.setAnchorLocation(toX, toY);

		if (isEdittingMoved) {// ҏWړꍇ
			// I_ҏWړ
			edittedPictureGroupEditor.setFocusPoint(oldFocusPoint);
			edittedPictureGroupEditor.edittingMoveByFocusPoint(toX, toY);

		} else if (isSimpleMoved) {// VKO[v͉̓ӏړꍇ
			if (movedTextGroup != null) {
				// ̃eLXgO[vړ
				movedTextGroup.setLocation(toX, toY);
			}

		} else if (isFixedAndMoved) {// m肵Ĉړꍇ

			// eLXgO[v𕜊
			currentPage.addGroup(createdTextGroup);
			createdTextGroup.getEditor().setEditable(true);

			// m肵eLXgO[vm肷
			fixedTextGroup.getEditor().setEditable(false);
		}

		// AJ[ړʒm
		getMode().anchorMoved();

		repaint();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		Page currentPage = getCurrentPage();

		// AJ[ʒuɖ߂
		currentPage.setAnchorLocation(oldX, oldY);

		if (isEdittingMoved) {// ҏWړꍇ
			// I_ҏWړ
			PictureGroupPane editor = getEditablePictureGroupPane();
			editor.setFocusPoint(oldFocusPoint);
			editor.edittingMoveByFocusPoint(oldX, oldY);

		} else if (isSimpleMoved) {// VKO[v͉̓ӏړꍇ
			if (movedTextGroup != null) {
				// ̃eLXgO[vړ
				movedTextGroup.setLocation(oldX, oldY);
			}

		} else if (isFixedAndMoved) {// m肵Ĉړꍇ

			// 쐬eLXgO[v폜
			currentPage.removeGroup(createdTextGroup);

			// m肵eLXgO[vҏWɖ߂
			fixedTextGroup.getEditor().setEditable(true);
		}

		// ԂJڑOɖ߂
		currentPage.getMode().setValue(oldMode);
		
		repaint();
	}

	/***************************************************************************
	 * toString
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#paramString()
	 */
	protected String paramString() {
		String typeText;
		if (type == ABSOLUTE) {
			typeText = "Absolute";
		} else if (type == RELATIVE) {
			typeText = "Relative";
		} else {
			typeText = "Error";
		}
		return "type=" + typeText + ",x=" + dx + "y=" + dy;
	}
}
