/*
 * Created on Jun 30, 2005
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.Iterator;
import java.util.List;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoableEdit;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.control.Pen;
import note.model.Page;
import note.model.Picture;
import note.model.PictureGroup;

/**
 * yύXR}hB<br>
 * TODO I͈͂̑ύXUndoł悤ɂB
 * 
 * @author camei
 * @version $Id: PenChangeCommand.java,v 1.5 2006/01/31 00:52:00 camei Exp $
 */
public class PenChangeCommand extends AbstractCommand {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private Pen pen;// ύXy̍

	// Undo
	private Pen oldPen = null;// ύXÕy
	private PictureGroup changedPictureGroup = null;// ύX}`O[v
	private PictureGroup oldPictureGroup = null;// ύXO̐}`O[v

	/**
	 * RXgN^
	 * 
	 * @param pen ύXy̍
	 * @param reciever V[o[
	 */
	public PenChangeCommand(Pen pen, NoteApplication reciever) {
		super(reciever);
		this.pen = pen;
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new PenChangeCommand((Pen) pen.clone(), getApplication());
	}

	/**
	 * @return ݎs\
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return true;
	}

	/**
	 * sB
	 * 
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		super.execute();

		NoteApplicationMode mode = getMode();

		oldPen = (Pen) getCurrentPen().clone();

		// ݂̃yɍǉ
		getCurrentPen().addAttribute(pen);

		if (mode.isTextMode()) {// eLXg̓[h̏ꍇ
			// eLXgO[ṽGfB^̕ύX
			getEditableTextGroupPane().setSelectionAttributes(pen, false);

		} else if (mode.isPictureMode()) {// }`̓[h̏ꍇ
			// I͈͂̐}`̑ύX
			// TODO ̕@ƁAł傫łĂ܂AoĂ܂B}`ɌŗL̘_TCY݂邱
			// TODO Qȏ̐}`̃TCYύXƂȊɂȂBS̓Iɑ傫ł悤ɂB
			PictureGroup pictureGroup = getEdittingPictureGroup();
			if (pictureGroup != null && pictureGroup.hasSelection()) {// I͈͂ꍇ
				// }`̑ύX
				double scaleSize = pen.getPictureSize();// ύXg嗦
				Color color = pen.getColor();// ύXF
				changedPictureGroup = pictureGroup;// Undo̕ۑ
				oldPictureGroup = (PictureGroup) pictureGroup.clone();// Undo̕ۑ

				List selectedPictures = pictureGroup.getSelectedPictureList();
				for (Iterator i = selectedPictures.iterator(); i.hasNext();) {
					Picture picture = (Picture) i.next();
					if (pen.isChangableSize()) {
						picture.scale(scaleSize, scaleSize);// g
					}
					if (pen.isChangableColor()) {
						picture.setColor(color);// FύX
					}
				}

				// AJ[ړ
				Point2D focusPoint = pictureGroup.getFocusPoint();
				int x = pictureGroup.getX() + (int) focusPoint.getX();
				int y = pictureGroup.getY() + (int) focusPoint.getY();
				getCurrentPage().setAnchorLocation(x, y);
			}
		}

		repaint();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// \
		return true;
	}

	/**
	 * @param anEdit ǉUndoableEdit
	 * @see javax.swing.undo.AbstractUndoableEdit#addEdit(javax.swing.undo.UndoableEdit)
	 */
	public boolean addEdit(UndoableEdit anEdit) {
		if (anEdit instanceof PenChangeCommand) {// yύX@\̏ꍇ
			// y̍
			pen.addAttribute(((PenChangeCommand) anEdit).getPen());
			return true;
		}
		return false;
	}

	/**
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return "y̕ύX";
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#isSignificant()
	 */
	public boolean isSignificant() {
		// 1XebvƂĈ
		return true;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		{// yɖ߂
			getCurrentPen().setValue(oldPen);
			// eLXgO[ṽGfB^̕ύX
			//getEdittingTextGroup().setCharacterAttributes(pen);
		}

		// ύXeLXg̑ɖ߂
		// TODO DocumentۑĎ

		// ύX}`̑ɖ߂
		if (changedPictureGroup != null) {
			Page page = getCurrentPage();
			page.removeGroup(changedPictureGroup);
			page.addGroup(oldPictureGroup);
		}

		repaint();
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	/**
	 * @return pen ߂B
	 */
	public Pen getPen() {
		return pen;
	}

}
