/**
 * 
 */
package note.command;

import java.awt.Point;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.Group;
import note.model.Page;
import note.model.Picture;
import note.model.PictureGroup;
import note.model.picture.PicturePoint;
import note.viewer.PictureGroupPane;

/**
 * ݂̐}`폜R}hB<br>
 * I͈͂ꍇ͑I͈͂̐}`폜BI͈͂Ȃꍇ͑I_̂}`폜B
 * 
 * @author camei
 * @version $Id: PictureDeleteCommand.java,v 1.7 2006/02/06 20:12:33 camei Exp $
 */
public class PictureDeleteCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	// 폜@
	/** 폜AqȂ폜@ */
	public static final int NOT_CONNECT = 1;
	/** 폜Aq폜@ */
	public static final int CONNECT = 2;// ͂ȂdlłȂB

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int type = NOT_CONNECT;

	// Undo
	private Collection removedPictures = new ArrayList();// 폜ꂽ}`
	private PictureGroupPane updatedPictureGroupEditor;// 폜ҏW}`O[ṽGfB^
	private Page updatedPage = null;// O[v폜y[W
	private PicturePoint oldFocusPoint;
	private PicturePoint afterFocusPoint = null;
	private Point afterAnchorPoint = null;
	private NoteApplicationMode oldMode = null;
	private boolean hasRemovedGroup = false;// O[v폜

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 * 
	 * @param type 폜@
	 * @param reciever V[o[
	 */
	public PictureDeleteCommand(int type, NoteApplication reciever) {
		super(reciever);

		assert (type == CONNECT || type == NOT_CONNECT) : "폜@̎w肪s.type="
				+ type;// O
		this.type = type;
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new PictureDeleteCommand(type, getApplication());
	}

	/**
	 * @return ̃R}hs\ǂ
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		// }`[h͒̏ꍇAs\
		NoteApplicationMode mode = getMode();
		return mode.isPictureMode() && mode.isInputting();
	}

	/**
	 * sB
	 * 
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		super.execute();

		PictureGroupPane editor = (PictureGroupPane) getEditableGroupEditor();
		updatedPictureGroupEditor = editor;
		oldFocusPoint = editor.getFocusPoint();// Undo̕ۑ
		oldMode = (NoteApplicationMode) getMode().clone();// Undo̕ۑ

		// I͈͂ɉĐ}`폜
		if (type == CONNECT) {// č폜ꍇ
			// TODO č폜݂͌Ȃ̂ő֏ĂB폜̎gpB
			if (editor.hasSelection()) {// I͈͂ꍇ
				// I͈͂̐}`B폜
				removedPictures.addAll(editor.removeSelection());// Undo̕ۑ

			} else {// I͈͂Ȃꍇ
				// I_̑O̐}`폜
				removedPictures.add(editor.removeFocusPrevious());// Undo̕ۑ
			}
		} else if (type == NOT_CONNECT) {// Ȃō폜ꍇ
			if (editor.hasSelection()) {// I͈͂ꍇ
				// I͈͂̐}`B폜
				removedPictures.addAll(editor.removeSelection());// Undo̕ۑ

			} else {// I͈͂Ȃꍇ
				// I_̎̐}`B폜
				removedPictures.addAll(editor.removeFocusNext());// Undo̕ۑ
			}
		} else {
			throw new Error("폜@̎w肪s");
		}

		Group group = editor.getGroup();
		if (group.isEmpty()) {// O[vɂȂꍇ
			// O[v폜
			updatedPage = getCurrentPage();
			updatedPage.removeGroup(group);
			hasRemovedGroup = true;
		}

		afterFocusPoint = editor.getFocusPoint();// Undo̕ۑ
		afterAnchorPoint = getCurrentPage().getAnchorPoint();

		repaint();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// 폜ꍇ\
		return !removedPictures.isEmpty();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return "}`̍폜";
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();

		// }`폜
		PictureGroup pictureGroup = (PictureGroup) updatedPictureGroupEditor
				.getGroup();
		pictureGroup.removeAll(removedPictures);

		// I_폜̈ʒuɈړ
		if (!pictureGroup.isEmpty()) {
			updatedPictureGroupEditor.setFocusPoint(afterFocusPoint);
		} else {
			getCurrentPage().setAnchorLocation(afterAnchorPoint);
		}

		if (hasRemovedGroup) {// O[v폜ꍇ
			// O[v폜
			updatedPage.removeGroup(updatedPictureGroupEditor.getGroup());
		}

		// ԑJ
		getMode().groupUpdated(pictureGroup);// TODO svBIɂ͂Ȃ񂾂ǂȂKvB

		repaint();// ĕ`
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		PictureGroup pictureGroup = (PictureGroup) updatedPictureGroupEditor
				.getGroup();

		// 폜O[v𕜊
		if (hasRemovedGroup) {
			updatedPage.addGroup(pictureGroup);
		}

		// 폜}`𕜊
		for (Iterator i = removedPictures.iterator(); i.hasNext();) {
			((Picture) i.next()).live();
		}
		pictureGroup.addAllPicture(removedPictures);

		// I_폜Öʒuɖ߂
		updatedPictureGroupEditor.setEditable(true);
		updatedPictureGroupEditor.setFocusPoint(oldFocusPoint);

		// ԂtJ
		getMode().setValue(oldMode);
		repaint();// ĕ`
	}

}
