/*
 * Created on Jun 30, 2005 Copyright (c) 2005 Nooto Poject. All rights reserved.
 */
package note.command;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.MediaName;
import javax.print.attribute.standard.MediaPrintableArea;
import javax.print.attribute.standard.MediaSize;
import javax.print.attribute.standard.OrientationRequested;
import javax.print.attribute.standard.PrinterResolution;
import javax.print.event.PrintJobAdapter;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

import note.NoteApplication;
import note.viewer.PageViewer;

/**
 * Class SaveCommand<br>
 * y[WR}h<br>
 * 
 * @author tajifu
 * @version $Id: PrintCommand.java,v 1.8 2006/02/09 02:14:29 tajifu Exp $
 */
public class PrintCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * \bh
	 **************************************************************************/

	/**
	 * RXgN^
	 * 
	 * @param reciever R}h̑Ώ
	 */
	public PrintCommand(NoteApplication reciever) {
		super(reciever);
	}

	public boolean canExecute() {
		return true;
	}

	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		DocFlavor flavor = DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		PrintRequestAttributeSet pras = new HashPrintRequestAttributeSet();
		
		
		//		pras.add(MediaSize.ISO.A4);
/*
		float margin = 5;
		float w = MediaSize.ISO.A4.getX(MediaSize.MM);
		float h = MediaSize.ISO.A4.getY(MediaSize.MM);
		float ww = w - margin;
		float hh = h - margin;
		pras.add(new MediaPrintableArea(margin, margin, ww, hh, MediaSize.MM));
*/

		
		// ftHg̃v^[T[rX̌
		PrintService defaultService = PrintServiceLookup
				.lookupDefaultPrintService();
		
		/*
		 * if (defaultService == null) { System.out.println("v^܂B");
		 * final JFrame frameN = new JFrame("Printer Not Found"); JLabel label =
		 * new JLabel("v^܂B"); JLabel label2 = new JLabel("");
		 * label.setOpaque(true);
		 * 
		 * Container contentPaneN = frameN.getContentPane();
		 * 
		 * contentPaneN.add(label,label.CENTER); frameN.setBounds(370, 200, 450,
		 * 280); frameN.show(); }
		 */
		
		
		// ̂ق̃T[rX̌
		PrintService printService[] = PrintServiceLookup.lookupPrintServices(
				flavor, pras);

		PrintJobListener pjlistener = new PrintJobAdapter() {
			public void printDataTransferCompleted(PrintJobEvent e) {
				System.out.println("Good-bye");
			}
		};

		// _CAO̕\
		PrintService service = ServiceUI.printDialog(null, 200, 200,
				printService, defaultService, flavor, pras);
		

		// _CAOŐݒłȂ̑̈̑A
//		int[] pages = { 1, 3, 5 };
//		boolean lineExists;

//		final JFrame frame = new JFrame("Printing Graphics");
//		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

//		Container contentPane = frame.getContentPane();

		
		PageViewer pv = this.getCurrentPageViewer();

		// R|[lg̎w
		final Component printIt = pv;

		// eXgp
		// contentPane.add(printIt, BorderLayout.CENTER);
		// frame.setSize(600, 600);
		// frame.show();

		// ̎s
		if (service != null) {
			DocPrintJob job = service.createPrintJob();
			job.addPrintJobListener(pjlistener);
			DocAttributeSet das = new HashDocAttributeSet();
		
			das.add(new MediaPrintableArea(80, 80, 1700, 2800, MediaPrintableArea.MM));
			
//			das.add(new PrinterResolution(380,380,380));
			
			Doc doc = new SimpleDoc(printIt, flavor, das);

			try {
				job.print(doc, pras);

			} catch (PrintException pe) {
				
/*				
				pe.printStackTrace();
				System.out.println("v^܂B");
				final JFrame frameN = new JFrame("Printer Not Found");
				JLabel label = new JLabel("v^܂B");
				JLabel label2 = new JLabel("");
				label.setOpaque(true);

				Container contentPaneN = frameN.getContentPane();

				contentPaneN.add(label, label.CENTER);
				frameN.setBounds(370, 200, 450, 280);
				frameN.show();
	*/			
				
			}
		}
	}

	
	/**
	 * @return R}h̕\߂B
	 */
	public String toString() {
		return getClass().getName() + "[" + paramString() + "]";
	}

	/*
	 * R}h̃p[^̕\߂B
	 */
	protected String paramString() {
		return "";
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new PrintCommand(getApplication());
	}

	/**
	 * @return Undo\ǂ
	 */
	public boolean isUndoableEdit() {
		return false;
	}
}
