/**
 * 
 */
package note.configuration;

import java.awt.event.KeyEvent;
import java.util.Iterator;
import java.util.List;

import javax.swing.InputMap;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.control.KeyCommandMap;
import note.control.NoteApplicationMode;

/**
 * L[ݒB
 * 
 * @author camei
 * @version $Id: KeyConfiguration.java,v 1.8 2006/02/08 21:09:28 camei Exp $
 */
public class KeyConfiguration {

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private ConceptualKeyConfiguration conceptualKeyConfiguration;// 샌x̃L[ݒ
	private SemanticsKeyConfiguration semanticsKeyConfiguration;// _x̃L[ݒ

	private NoteApplication application;// @\p̖{̂ւ̎Q

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 */
	public KeyConfiguration(NoteApplication application) {
		this.application = application;

		// 샌x̃L[ݒ
		semanticsKeyConfiguration = new SemanticsKeyConfiguration();

		// L[ݒXMLt@C͂āA_x̃L[ݒݒ肷
		KeyConfigurationXMLParser parser = new KeyConfigurationXMLParser();// p[T𐶐
		conceptualKeyConfiguration = parser.parse();

		// _x̃L[ݒA샌x̃L[ݒɔf
		reflectSemanticsConfiguration();
		
		// InputMap
//		textModeInputMap.setParent(anchorMoveInputMap);
//		textModeInputMap.setParent(functionKeyInputMap);
//		pictureModeInputMap.setParent(anchorMoveInputMap);
//		pictureModeInputMap.setParent(functionKeyInputMap);

		// TODO 
	}

//	private InputMap textModeInputMap;
//	private InputMap pictureModeInputMap;
//	private InputMap anchorMoveInputMap;
//	private InputMap functionKeyInputMap;
//
//	private void setInputMapByConceptualKeyConfiguration() {
//		List functionKeyConfigList = conceptualKeyConfiguration.getFunctionKeyConfigurationList();
//		for (Iterator i = functinoKeyConfigList.iterator(); i.hasNext();){
//			
//		}
//	}
//	public InputMap getTextModeInputMap(){
//		return textModeInputMap;
//	}
//	
//	public InputMap getPictureModeInputMap(){
//		return pictureModeInputMap;
//	}
//	
//	public InputMap getFunctionKeyInputMap(){
//		return functionKeyInputMap;
//	}
	
	/**
	 * L[CxgɑΉR}h߂B
	 * 
	 * @param mode [h
	 * @param e L[Cxg
	 * @return ΉR}h
	 */
	public AbstractCommand getCommand(NoteApplicationMode mode, KeyEvent e) {
		return getCommand(mode, e.getID(), e.getKeyCode(), e.getModifiers());
	}

	/**
	 * L[CxgɑΉR}h߂B
	 * 
	 * @param mode [h
	 * @param id L[CxgIDiKEY_PRESSEDj
	 * @param keyCode L[R[h
	 * @param modifiers CL[
	 * @return ΉR}hBΉR}hꍇ<code>null</code>߂B
	 */
	public AbstractCommand getCommand(NoteApplicationMode mode, int id,
			int keyCode, int modifiers) {
		KeyCommandMap anchorMoveKeyMap = semanticsKeyConfiguration
				.getAnchorMoveKeyMap();
		KeyCommandMap functionKeyMap = semanticsKeyConfiguration
				.getFunctionKeyMap();
		KeyCommandMap pictureKeyMap = semanticsKeyConfiguration
				.getPictureKeyMap();
		KeyCommandMap miscKeyMap = semanticsKeyConfiguration.getMiscKeyMap();

		switch (id) {
		case KeyEvent.KEY_PRESSED:// L[ꂽꍇ
			if (anchorMoveKeyMap.containsKey(keyCode, modifiers)) {
				return anchorMoveKeyMap.getCommand(keyCode, modifiers);
			}

			KeyCommandMap pressed = semanticsKeyConfiguration
					.getKeyPressedKeyMap();
			if (pressed.containsKey(keyCode, modifiers)) {
				return pressed.getCommand(keyCode, modifiers);
			}
			return null;

		case KeyEvent.KEY_RELEASED:// L[ꂽꍇ
			KeyCommandMap released = semanticsKeyConfiguration
					.getKeyReleasedKeyMap();
			if (released.containsKey(keyCode, modifiers)) {
				return released.getCommand(keyCode, modifiers);
			}

			if (functionKeyMap.containsKey(keyCode, modifiers)) {
				return functionKeyMap.getCommand(keyCode, modifiers);
			}
			if (miscKeyMap.containsKey(keyCode, modifiers)) {
				return miscKeyMap.getCommand(keyCode, modifiers);
			}

			if (mode.isPictureMode()) {// }`̓[h̏ꍇ
				if (pictureKeyMap.containsKey(keyCode, modifiers)) {
					return pictureKeyMap.getCommand(keyCode, modifiers);
				}
			}
			return null;
		case KeyEvent.KEY_TYPED:// L[^Cvꂽꍇ
			return null;
		default:
			throw new RuntimeException("id̎w肪sł");

		}
	}

//	public KeyStroke getKeyStroke(String commandKey){
//		KeyCommandMap functionKeyMap = semanticsKeyConfiguration.getFunctionKeyMap();
//		if(functionKeyMap.c)
//	}
	
	/**
	 * _x̃L[ݒL[ݒXMLt@Cɏo͂
	 */
	public void save() {
		// TODO JARɃG[ł邽ߐݒt@C̕ۑ͂ȂłBāB
//		// o͋@\pӂ
//		KeyConfigurationXMLSerializer serializer = new KeyConfigurationXMLSerializer();
//
//		// _x̃L[ݒL[ݒXMLt@Cɏo͂
//		serializer.serialize(conceptualKeyConfiguration);
	}

	/**
	 * _x̃L[ݒA샌x̃L[ݒɔfB
	 */
	public void reflectSemanticsConfiguration() {
		semanticsKeyConfiguration.setValue(conceptualKeyConfiguration,
				application);
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	public KeyCommandMap getAnchorMoveKeyMap() {
		return semanticsKeyConfiguration.getAnchorMoveKeyMap();
	}

	public KeyCommandMap getFunctionKeyMap() {
		return semanticsKeyConfiguration.getFunctionKeyMap();
	}

	public KeyCommandMap getPictureKeyMap() {
		return semanticsKeyConfiguration.getPictureKeyMap();
	}

	public KeyCommandMap getMiscKeyMap() {
		return semanticsKeyConfiguration.getMiscKeyMap();
	}

	public int getMoveKeyModifiers() {
		return semanticsKeyConfiguration.getMoveKeyModifiers();
	}

}
