package note.configuration.element;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.AnchorMoveCommand;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * AJ[ړ@\̐ݒvfB
 * 
 * @author camei
 * @version $Id: AnchorMoveFunctionConfigurationElement.java,v 1.1 2005/11/19
 *          01:49:39 camei Exp $
 */
public class AnchorMoveFunctionConfigurationElement extends
		AbstractFunctionConfigurationElement {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	// ړ萔
	public static final int RELATIVE = 1;// Έړ
	public static final int ABSOLUTE = 2;// Έړ

	// XML֌W
	private static final String TAG_NAME = "anchormove";
	private static final String ABSOLUTE_VALUE = "absolute";
	private static final String RELATIVE_VALUE = "relative";
	private static final String Y_ATTRIBUTE = "y";
	private static final String X_ATTRIBUTE = "x";
	private static final String TYPE_ATTRIBUTE = "type";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private int movingType;// ړ@
	private int x;
	private int y;

	/***************************************************************************
	 * \bh
	 **************************************************************************/

	/*
	 * @see note.configuration.element.AbstractFunctionConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new AnchorMoveFunctionConfigurationElement();
	}

	public AbstractCommand getFunction(NoteApplication application) {
		if (movingType == RELATIVE) {// Έړ̏ꍇ
			return new AnchorMoveCommand(AnchorMoveCommand.RELATIVE, x, y,
					application);
		} else if (movingType == ABSOLUTE) {// Έړ̏ꍇ
			return new AnchorMoveCommand(AnchorMoveCommand.ABSOLUTE, x, y,
					application);
		} else {
			throw new RuntimeException("ړ@̋Lqsł");
		}
	}

	public void setValue(Element element) {
		String typeText = element.getAttribute(TYPE_ATTRIBUTE);// ړ@
		this.x = Integer.parseInt(element.getAttribute(X_ATTRIBUTE));// ړW
		this.y = Integer.parseInt(element.getAttribute(Y_ATTRIBUTE));

		// ړ@̎w͂
		if (typeText.equals(RELATIVE_VALUE) || typeText.equals("")) {// Έړw肳Ăꍇ
			movingType = RELATIVE;
		} else if (typeText.equals(ABSOLUTE_VALUE)) {// Έړw肳Ăꍇ
			movingType = ABSOLUTE;
		}
	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);
		String typeText;// ړ@XMLLq

		if (movingType == RELATIVE) {
			typeText = RELATIVE_VALUE;
		} else if (movingType == ABSOLUTE) {
			typeText = ABSOLUTE_VALUE;
		} else {
			throw new RuntimeException("ړ@̐ݒ肪sł");
		}
		element.setAttribute(TYPE_ATTRIBUTE, typeText);

		element.setAttribute(X_ATTRIBUTE, Integer.toString(x));
		element.setAttribute(Y_ATTRIBUTE, Integer.toString(y));

		return element;
	}
}