package note.configuration.element;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.ModeChangeCommand;
import note.control.NoteApplicationMode;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * [hύX@\̗vfB
 * @author camei
 * @version $Id: ModeChangeFunctionConfigurationElement.java,v 1.2 2005/12/14 12:04:37 camei Exp $
 */
public class ModeChangeFunctionConfigurationElement extends
		AbstractFunctionConfigurationElement {

	/***************************************************************************
	 * 萔
	 **************************************************************************/

	private static final String TAG_NAME = "modechange";
	private static final String NAME_ATTRIBUTE = "name";
	private static final String TEXT_MODE_VALUE = "text";
	private static final String PICTURE_MODE_VALUE = "picture";
	private static final String EDIT_MODE_VALUE = "edit";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private int mode;// ύX郂[hiύX̃[hj

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * @see note.configuration.element.AbstractFunctionConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new ModeChangeFunctionConfigurationElement();
	}

	public AbstractCommand getFunction(NoteApplication application) {
		return new ModeChangeCommand(mode, application);
	}

	public void setValue(Element element) {
		String name = element.getAttribute(NAME_ATTRIBUTE);

		if (name.equals(TEXT_MODE_VALUE)) {
			mode = NoteApplicationMode.TEXT_MODE;
		} else if (name.equals(PICTURE_MODE_VALUE)) {
			mode = NoteApplicationMode.PICTURE_MODE;
		} else if (name.equals(EDIT_MODE_VALUE)) {
			mode = 100;// TODO ҏW[h100B100͐ݒG[oȂ߂̎b菈
			// TODO  mode=ҏW[h Ƃ
		} else {
			throw new RuntimeException("[h̖ŐLqsł");
		}

	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);
		String name;
		if (mode == NoteApplicationMode.TEXT_MODE) {
			name = TEXT_MODE_VALUE;
		} else if (mode == NoteApplicationMode.PICTURE_MODE) {
			name = PICTURE_MODE_VALUE;
		} else if (mode == 100) {// TODO ҏW[h100B100̓G[oȂ߂̎b菈u
			name = EDIT_MODE_VALUE;
		} else {
			throw new RuntimeException("[h̐ݒ肪sł");
		}
		element.setAttribute("name", name);

		return element;
	}

}