/**
 * 
 */
package note.configuration.element;

import java.awt.event.KeyEvent;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * ړCqL[̐ݒvfB
 * 
 * @author camei
 * @version $Id: MoveKeyModifiersConfigurationElement.java,v 1.2 2006/01/28 00:13:56 camei Exp $
 */
public class MoveKeyModifiersConfigurationElement extends AbstractConfigurationElement {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final String TAG_NAME = "modifier";
	private static final String CODE_ATTRIBUTE = "code";
	private static final String ALT_VALUE = "alt";
	private static final String SHIFT_VALUE = "shift";
	private static final String CTRL_VALUE = "ctrl";

	/***************************************************************************
	 * 
	 **************************************************************************/
	// ړCqL[i2͓ƂĂj
	private int keyCode;// ړCqL[
	private String keyText;// ړCqL[̕\

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * @see note.configuration.element.AbstractConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	/*
	 * @see note.configuration.element.AbstractConfigurationElement#getNewInstance()
	 */
	public AbstractConfigurationElement getNewInstance() {
		return new MoveKeyModifiersConfigurationElement();
	}

	/*
	 * @see note.configuration.element.AbstractConfigurationElement#setValue(org.w3c.dom.Element)
	 */
	public void setValue(Element element) {
		// ړCqL[ۑ
		setKeyText(element.getAttribute(CODE_ATTRIBUTE));
	}

	/*
	 * @see note.configuration.element.AbstractConfigurationElement#parseXMLElement()
	 */
	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);

		element.setAttribute(CODE_ATTRIBUTE, keyText);

		return element;
	}

	/*
	 * L[̐l\𕶎\ɕϊ
	 */
	private int parseKeyCode(String keyText) {
		if (keyText.equals(ALT_VALUE)) {
			return KeyEvent.VK_ALT;

		} else if (keyText.equals(SHIFT_VALUE)) {
			return KeyEvent.VK_SHIFT;

		} else if (keyText.equals(CTRL_VALUE)) {
			return KeyEvent.VK_CONTROL;
		} else {
			throw new RuntimeException("ړCqL[\𐮐lɕϊł܂");
		}
	}

	/*
	 * L[̕\𐮐l\ɕϊ
	 */
	private String parseKeyText(int keyCode) {
		if (keyCode == KeyEvent.ALT_MASK) {
			return ALT_VALUE;

		} else if (keyCode == KeyEvent.SHIFT_MASK) {
			return SHIFT_VALUE;

		} else if (keyCode == KeyEvent.CTRL_MASK) {
			return CTRL_VALUE;

		} else {
			throw new RuntimeException("ړCqL[l𕶎\ɕϊł܂");
		}
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return keyCode ߂܂B
	 */
	public int getKeyCode() {
		return keyCode;
	}

	/**
	 * @param keyCode
	 *            ݒ肷 keyCodeB
	 */
	public void setKeyCode(int keyCode) {
		this.keyCode = keyCode;
		this.keyText = parseKeyText(keyCode);
	}

	/**
	 * @return keyText ߂܂B
	 */
	public String getKeyText() {
		return keyText;
	}

	/**
	 * @param keyText
	 *            ݒ肷 keyCodeTextB
	 */
	public void setKeyText(String keyText) {
		this.keyText = keyText;
		this.keyCode = parseKeyCode(keyText);
	}

}
