package note.configuration.element;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.TargetPicturePointMoveCommand;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * ҏW_ړ@\̐ݒvfB
 * 
 * @author camei
 * @version $Id: TargetPicturePointMoveFunctionConfigurationElement.java,v 1.2 2005/12/14 12:04:37 camei Exp $
 */
public class TargetPicturePointMoveFunctionConfigurationElement extends
		AbstractFunctionConfigurationElement {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final String DIRECTION_ATTRIBUTE = "direct";
	private static final String TAG_NAME = "targetpicturepointmove";
	private static final String RIGHT_VALUE = "right";
	private static final String LEFT_VALUE = "left";
	private static final String DOWN_VALUE = "down";
	private static final String UP_VALUE = "up";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private int direction;// ړ

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * @see note.configuration.element.AbstractFunctionConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new TargetPicturePointMoveFunctionConfigurationElement();
	}

	public AbstractCommand getFunction(NoteApplication application) {
		return new TargetPicturePointMoveCommand(direction, application);
	}

	public void setValue(Element element) {
		String directionText = element.getAttribute(DIRECTION_ATTRIBUTE);
		if (directionText.equals(UP_VALUE)) {
			direction = TargetPicturePointMoveCommand.UP;
		} else if (directionText.equals(DOWN_VALUE)) {
			direction = TargetPicturePointMoveCommand.DOWN;
		} else if (directionText.equals(LEFT_VALUE)) {
			direction = TargetPicturePointMoveCommand.LEFT;
		} else if (directionText.equals(RIGHT_VALUE)) {
			direction = TargetPicturePointMoveCommand.RIGHT;
		}
	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);

		String directionText = "";
		if (direction == TargetPicturePointMoveCommand.UP) {
			directionText = UP_VALUE;
		} else if (direction == TargetPicturePointMoveCommand.DOWN) {
			directionText = DOWN_VALUE;
		} else if (direction == TargetPicturePointMoveCommand.LEFT) {
			directionText = LEFT_VALUE;
		} else if (direction == TargetPicturePointMoveCommand.RIGHT) {
			directionText = RIGHT_VALUE;
		}
		element.setAttribute(DIRECTION_ATTRIBUTE, directionText);
		return element;
	}
}