/*
 * Created on Jun 30, 2005
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.control;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.io.Serializable;

import javax.swing.Icon;

/**
 * Class Pen <br>
 * yB܂́AyύXۂ̍B <br>
 * TCYɂ3iKŕ\_TCYw肵ATCY𒼐ڎw͂ȂB <br>
 * 
 * @author camei
 * @version $Id: Pen.java,v 1.4 2006/01/10 07:19:36 tajifu Exp $
 */
public class Pen implements Icon, Cloneable{
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	// _yTCY萔
	/** TCY */
	public static final int SMALL = 1;
	/** TCY */
	public static final int MIDDLE = 2;
	/** TCY */
	public static final int LARGE = 3;
	/** TCYύXȂ */
	public static final int UNCHANGE = -1;

	// ݒ
	private static final Color DEFAULT_COLOR = Color.BLACK;
	private static final int DEFAULT_SIZE = MIDDLE;
	private static final String DEFAULT_FONT_FAMILY = "Monospaced";

	// tHgTCYƃyTCY̑Ή萔
	private static final int FONT_SIZE_SMALL = 9;
	private static final int FONT_SIZE_MIDDLE = 12;
	private static final int FONT_SIZE_LARGE = 20;

	// }`̊g嗦ƃyTCY̑Ή萔
	private static final double PICTURE_SCALE_SMALL = 0.5;
	private static final double PICTURE_SCALE_MIDDLE = 1.0;
	private static final double PICTURE_SCALE_LARGE = 2.0;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private Color color = null;// F
	private int size = UNCHANGE;// y̘_TCY
	private String fontFamily = null;// tHgt@~

	// 
	private boolean isChangableColor = false;// FύX邩
	private boolean isChangableSize = false;// TCYύX邩
	private boolean isChangableFontFamily = false;// tHgύX邩

	// <<view>>
	private int fontSize;// tHg̃TCY
	private double pictureSize;// }`̃TCYi{j

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B <br>
	 * fBtHg̃y𐶐B
	 */
	public Pen() {
		this(DEFAULT_COLOR, DEFAULT_SIZE, DEFAULT_FONT_FAMILY);
	}

	/**
	 * RXgN^B<br>
	 * w肵FƃTCYɕύX鍷̃y𐶐B
	 * 
	 * @param color ύXFBύXȂꍇnullw肷
	 * @param size ύXTCYBύXȂꍇUNCHANGEw肷
	 */
	public Pen(Color color, int size) {
		this(color, size, null);
	}

	/**
	 * RXgN^B<br>
	 * w肵FƃTCYƃtHgɕύX鍷̃y𐶐B
	 * 
	 * @param color ύXFBύXȂꍇnullw肷
	 * @param size ύXTCYBύXȂꍇUNCHANGEw肷
	 * @param fontFamily ύXtHgBύXȂꍇnullw肷
	 */
	public Pen(Color color, int size, String fontFamily) {
		// Fݒ肷
		if (color != null) {// Fw肳Ăꍇ
			this.color = color;
			this.isChangableColor = true;// FύX\ɂ
		}

		// _TCYݒ肷
		try {
			setSize(size);
		} catch (AssertionError e) {
			throw new RuntimeException(e.toString());
		}

		// tHgݒ肷
		if (fontFamily != null) {
			this.fontFamily = fontFamily;
			this.isChangableFontFamily = true;// tHgύX\ɂ
		}

	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		Pen clone = new Pen(color,size,fontFamily);
//		Pen clone = new Pen();
//		clone.color = this.color;
//		clone.size = this.size;
//		clone.fontFamily = this.fontFamily;
//		clone.isChangableColor = this.isChangableColor;
//		clone.isChangableSize = this.isChangableSize;
//		clone.isChangableFontFamily = this.isChangableFontFamily;
		return clone;
	}

	/**
	 * y̍B
	 * 
	 * @param pen y̍
	 */
	public void addAttribute(Pen pen) {
		// O
		if (!pen.isInvariant()) {
			throw new RuntimeException("sȃyw肳܂");
		}

		// ̕ύX\ǂɉčύX
		if (pen.isChangableColor) {
			this.color = pen.getColor();
		}
		if (pen.isChangableSize) {
			this.setSize(pen.getSize());
			// this.pictureSize = pen.getPictureSize();
			// this.fontSize = pen.getFontSize();
			// this.size = pen.getSize();
		}
		if (pen.isChangableFontFamily) {
			this.fontFamily = pen.getFontFamily();
		}
	}

	/*
	 * y̘_TCYw肷B
	 */
	private void setSize(int size) {
		assert (size == SMALL || size == MIDDLE || size == LARGE || size == UNCHANGE) : "K肳ĂȂTCYw肳܂,size="
				+ size;// O

		// ỹTCYύX
		this.size = size;

		if (size != UNCHANGE) {
			// tHgTCYƐ}`TCYύX
			this.fontSize = getFontSize(size);
			this.pictureSize = getPictureSize(size);
			this.isChangableSize = true;
		} else {
			this.isChangableSize = false;
		}
	}

	/*
	 * sϏ𒲂ׁAǂ߂B
	 */
	private boolean isInvariant() {
		if ((size == LARGE && fontSize == FONT_SIZE_LARGE && pictureSize == PICTURE_SCALE_LARGE)
				|| (size == MIDDLE && fontSize == FONT_SIZE_MIDDLE && pictureSize == PICTURE_SCALE_MIDDLE)
				|| (size == SMALL && fontSize == FONT_SIZE_SMALL && pictureSize == PICTURE_SCALE_SMALL)
				|| (size == UNCHANGE)) {
			return true;
		} else {
			return false;
		}
	}

	/***************************************************************************
	 * toString
	 **************************************************************************/
	/**
	 * y̑̕\Ԃ܂B<br>
	 * ̏ꍇ͕ύX\ȑ̂ݕ\܂B
	 * 
	 * @return ̃y̕\߂B
	 */
	public String toString() {
		StringBuffer state = new StringBuffer("Pen[");

		state.append("size=");
		if (isChangableSize) {
			if (size == SMALL) {
				state.append("SMALL");
			} else if (size == MIDDLE) {
				state.append("MIDDLE");
			} else if (size == LARGE) {
				state.append("LARGE");
			} else {
				state.append("UNKNOWN");
			}
			state.append(",pictureSize=" + pictureSize);
			state.append(",fontSize=" + fontSize);
		} else {
			state.append("unchange");
		}

		state.append(",color=");
		if (isChangableColor) {
			state.append(color.toString());
		} else {
			state.append("unchange");
		}

		state.append(",fontFamily=");
		if (isChangableFontFamily) {
			state.append(fontFamily);
		} else {
			state.append("unchange");
		}

		state.append("]");
		return state.toString();
	}

	/***************************************************************************
	 * Icon C^[tFCX̎
	 **************************************************************************/
	/**
	 * ACR`悷B
	 * 
	 * @param component `挳R|[lg
	 * @param g OtBbNXReLXg
	 * @param x `ʒuxW
	 * @param y `ʒuyW
	 * @see javax.swing.Icon#paintIcon(java.awt.Component, java.awt.Graphics,
	 * int, int)
	 */
	public void paintIcon(Component component, Graphics g, int x, int y) {
		g.setFont(new Font(fontFamily, Font.PLAIN, fontSize));
		g.setColor(color);

		String state;
		if (size == SMALL) {
			state = "";
		} else if (size == MIDDLE) {
			state = "";
		} else if (size == LARGE) {
			state = "";
		} else {
			state = "UN";
		}
		g.drawString(state, x, y + fontSize);
	}

	/**
	 * @return ACR̍
	 * @see javax.swing.Icon#getIconHeight()
	 */
	public int getIconHeight() {
		return 20;
	}

	/**
	 * @return ACR̕
	 * @see javax.swing.Icon#getIconWidth()
	 */
	public int getIconWidth() {
		return 20;
	}

	/***************************************************************************
	 * static \bh
	 **************************************************************************/
	/**
	 * w肳ꂽyTCYɑ΂tHgTCYԂB
	 * 
	 * @param size yTCY
	 * @return tHgTCY
	 */
	public static int getFontSize(int size) {
		if (size == SMALL) {
			return FONT_SIZE_SMALL;
		} else if (size == MIDDLE) {
			return FONT_SIZE_MIDDLE;
		} else if (size == LARGE) {
			return FONT_SIZE_LARGE;
		} else {
			throw new RuntimeException("K肵ĂȂyTCYw肳܂");
		}
	}

	/**
	 * w肳ꂽyTCYɑ΂}`̃TCY߂B
	 * 
	 * @param size yTCY
	 * @return }`̊g嗦
	 */
	public static double getPictureSize(int size) {
		if (size == SMALL) {
			return PICTURE_SCALE_SMALL;
		} else if (size == MIDDLE) {
			return PICTURE_SCALE_MIDDLE;
		} else if (size == LARGE) {
			return PICTURE_SCALE_LARGE;
		} else {
			throw new RuntimeException("K肵ĂȂyTCYw肳܂");
		}
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	/**
	 * @return TCY傩ǂ
	 */
	public boolean isTextLarge() {
		return this.getFontSize() == FONT_SIZE_LARGE;
	}

	/**
	 * @return TCYǂ
	 */
	public boolean isTextMiddle() {
		return this.getFontSize() == FONT_SIZE_MIDDLE;
	}

	/**
	 * @return TCYǂ
	 */
	public boolean isTextSmall() {
		return this.getFontSize() == FONT_SIZE_SMALL;
	}

	/**
	 * @return }`TCY傩ǂ
	 */
	public boolean isPictureLarge() {
		return this.getPictureSize() == PICTURE_SCALE_LARGE;
	}

	/**
	 * @return }`TCYǂ
	 */
	public boolean isPictureMiddle() {
		return this.getPictureSize() == PICTURE_SCALE_MIDDLE;
	}

	/**
	 * @return }`TCYǂ
	 */
	public boolean isPictureSmall() {
		return this.getPictureSize() == PICTURE_SCALE_SMALL;
	}

	/**
	 * @return }`TCY
	 */
	public double getPictureSize() {
		return pictureSize;
	}

	/**
	 * @return F
	 */
	public Color getColor() {
		return color;
	}

	/**
	 * y̘_TCYԂB
	 * 
	 * @return PenŋK肳Ă_TCY
	 */
	public int getSize() {
		return size;
	}

	/**
	 * tHgTCYԂB
	 * 
	 * @return tHgTCY
	 */
	public int getFontSize() {
		return fontSize;
	}

	/**
	 * @return fontFamily ߂B
	 */
	public String getFontFamily() {
		return fontFamily;
	}

	/**
	 * @return isChangableColor ߂B
	 */
	public boolean isChangableColor() {
		return isChangableColor;
	}

	/**
	 * @return isChangableFontFamily ߂B
	 */
	public boolean isChangableFontFamily() {
		return isChangableFontFamily;
	}

	/**
	 * @return isChangableSize ߂B
	 */
	public boolean isChangableSize() {
		return isChangableSize;
	}

	/**
	 * SĂ̒lݒ肷B
	 * 
	 * @param pen y
	 */
	public void setValue(Pen pen) {
		// O
		if (!pen.isInvariant()) {
			throw new RuntimeException("sȃyw肳܂");
		}

		this.color = pen.color;
		this.size = pen.size;
		this.fontFamily = pen.fontFamily;
		this.isChangableColor = pen.isChangableColor;
		this.isChangableSize = pen.isChangableSize;
		this.isChangableFontFamily = pen.isChangableFontFamily;
	}
}
