/*
 * 쐬: 2005/06/16
 */
package note.model;

import java.awt.Rectangle;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import note.viewer.GroupEditor;

/**
 * O[vB<br>
 * ̂Ƃ̓̓IuWFNg̃O[v\B<br>
 * 
 * @author camei
 * @version $Id: Group.java,v 1.10 2006/01/31 11:04:52 tajifu Exp $
 */
public abstract class Group implements Serializable, Cloneable {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	// // 
	// private static final int FIXED = 1;// m
	// private static final int EDITABLE = 2;// ҏW
	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	// // 
	// private int state = EDITABLE;
	// W
	private int x;
	private int y;

	// Xi[
	private transient GroupChangedListener groupChangedListener = null;

	private transient GroupEditor editor;

	/***************************************************************************
	 * \bh
	 **************************************************************************/

	/**
	 * RXgN^B
	 * 
	 * @param x O[vxW
	 * @param y O[vyW
	 */
	public Group(int x, int y) {
		this.x = x;
		this.y = y;
	}

	/**
	 * O[v̕߂B
	 * 
	 * @return O[v̕
	 */
	public abstract Object clone();

	// /**
	// * O[vm肷
	// */
	// public void fix() {
	// if (state == EDITABLE) {
	// state = FIXED;
	// fireFixedUpdate();
	// }
	// }
	//
	// /**
	// * O[vҏW
	// */
	// public void edit() {
	// if (state == FIXED) {
	// state = EDITABLE;
	// fireEditedUpdate();
	// }
	// }

	public void setEditor(GroupEditor editor) {
		this.editor = editor;
	}

	public GroupEditor getEditor() {
		return editor;
	}

	/**
	 * ړB<br>
	 * 
	 * @param dx xړ
	 * @param dy yړ
	 */
	public void translate(int dx, int dy) {
		setLocation(x + dx, y + dy);
	}

	/**
	 * @return ̃O[v̋`̈
	 */
	public abstract Rectangle getBounds();

	/***************************************************************************
	 * I֘A
	 **************************************************************************/

	// /**
	// * I͈͂
	// */
	// public abstract void releaseSelection();
	//
	// /**
	// * @return O[vI͈͂Ă邩ǂ
	// */
	// public abstract boolean hasSelection();
	/**
	 * y[WWnłĂꂽW܂ł邩ǂ肷B
	 * 
	 * @param x x
	 * @param y y
	 * @return ̃O[vw肵W܂ł邩
	 */
	public abstract boolean contains(int x, int y);

	/**
	 * y[WWnłĂꂽ`̃O[vƌ邩ǂ肷B
	 * 
	 * @param x x
	 * @param y y
	 * @param width width
	 * @param height height
	 * @return ̃O[vw肵`ƌ邩
	 */
	public abstract boolean intersects(int x, int y, int width, int height);

	/***************************************************************************
	 * GroupChnagedListener ֘A
	 **************************************************************************/
	/**
	 * O[vύX̃Xi[ǉB
	 * 
	 * @param listener ǉ郊Xi[
	 */
	public void addGroupChangedListener(GroupChangedListener listener) {
		groupChangedListener = listener;
	}

	/**
	 * O[vύX̃Xi[폜B
	 * 
	 * @param listener 폜郊Xi[
	 * @return Xi[폜łǂ
	 */

	public boolean removeGroupChangedListener(GroupChangedListener listener) {
		groupChangedListener = null;
		return true;
	}

	// /*
	// * mԂɂXVXi[ɒʒmB
	// */
	// private void fireFixedUpdate() {
	// for (int i = 0; i < groupChangedListenerList.size(); i++) {
	// ((GroupChangedListener) groupChangedListenerList.get(i))
	// .fixedUpdate(this);
	// }
	// }
	//
	// /*
	// * ҏWԂɂXVXi[ɒʒmB
	// */
	// private void fireEditedUpdate() {
	// for (int i = 0; i < groupChangedListenerList.size(); i++) {
	// ((GroupChangedListener) groupChangedListenerList.get(i))
	// .editedUpdate(this);
	// }
	// }

	/*
	 * ύXXVXi[ɒʒmB
	 */
	protected final void fireChangedUpdate() {
		if (groupChangedListener != null) {
			groupChangedListener.changedUpdate(this);
		}
	}

	/*
	 * ړXVXi[ɒʒmB
	 */
	protected final void fireMovedUpdate() {
		if (groupChangedListener != null) {
			groupChangedListener.movedUpdate(this);
		}
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return x
	 */
	public int getX() {
		return x;
	}

	/**
	 * @return y
	 */
	public int getY() {
		return y;
	}

	/**
	 * ʒuw肷B<br>
	 * Page ̍WnB
	 * 
	 * @param x xW
	 * @param y yW
	 */
	public void setLocation(int x, int y) {
		this.x = x;
		this.y = y;
		fireMovedUpdate();
	}

	// /**
	// * @return ҏW\Ԃǂ
	// */
	// public boolean isEditable() {
	// return state == EDITABLE;
	// }
	//
	// /**
	// * @return ҏWs\Ԃǂ
	// */
	// public boolean isFixed() {
	// return state == FIXED;
	// }

	/**
	 * @return O[v̒g󂩂ǂ
	 */
	public abstract boolean isEmpty();
}
