package note.model;

import java.awt.Color;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.NoninvertibleTransformException;
import java.awt.geom.Point2D;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import note.model.picture.PictureDesign;
import note.model.picture.PicturePoint;

/**
 * }`\B <br>
 * }`ɂ͐݌viKƋ̒iKB <br>
 * ܂݌viKƂăCX^XACX^X̃Rs[̉ē\B <br>
 * TODO live,kill\bh͐eiPictureGroupjۑ悤ɂāAꂪ}`ǂȂό`CxgA悤ɂΖB
 * @author camei
 * @version $Id: Picture.java,v 1.3 2006/02/08 04:22:29 tajifu Exp $
 */
public class Picture extends AbstractElement implements Cloneable, Serializable {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	private static final Color DEFAULT_COLOR = Color.BLACK;

	/***************************************************************************
	 * 
	 **************************************************************************/
	// ݌v
	private PictureDesign design = null;

	// ̑
	protected PicturePoint begin; // n_
	protected PicturePoint end; // I_
	protected PicturePoint[] controls; // _
	protected Set allEditPoints = new HashSet(); // <<view>>SĂ̕ҏW_in_AI_A_j
	protected PictureGroup parentGroup = null;// eO[v

	/*
	 * }`ɉꂽό`B pointsscale,rotate,translatȅɓKp̂̍WɂȂB
	 * ̍Wɖ߂ɂ͋tɓKpB
	 */
	protected AffineTransform scale = new AffineTransform();// g
	protected AffineTransform rotate = new AffineTransform();// ]
	protected AffineTransform translate = new AffineTransform();// ړ

	// `摮
	protected Color color = DEFAULT_COLOR;// }`̐F

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	
	/**
	 * RXgN^B
	 */
	protected Picture() {
	}

	/**
	 * RXgN^B<br>
	 * }`݌v}}`𐶐B
	 * 
	 * @param design }`݌v}
	 */
	public Picture(PictureDesign design) {
		this.design = design;
	}

	/***************************************************************************
	 * clone
	 **************************************************************************/
	/**
	 * ̐}`̕߂B<br>
	 * 
	 * @return
	 */
	public Object clone() {

		// ݌vRs[
		// Picture clone = (Picture) this.clone();
		Picture clone = new Picture(design);

		// ̑Rs[
		// clone.isInitialize = isInitialize;
		// clone.name = name;
		clone.color = color;

		// }`_Rs[
		clone.begin = null;// begin̓Rs[Ȃi蓮Őݒ肷邱Ɓj

		clone.end = (PicturePoint) end.clone();
		clone.end.addParent(clone);
		clone.allEditPoints.add(clone.end);

		clone.controls = new PicturePoint[controls.length];
		for (int i = 0; i < controls.length; i++) {
			clone.controls[i] = (PicturePoint) controls[i].clone();
			clone.controls[i].addParent(clone);
			clone.allEditPoints.add(clone.controls[i]);
		}

		// ϊWRs[
		clone.rotate = (AffineTransform) rotate.clone();
		clone.translate = (AffineTransform) translate.clone();
		clone.scale = (AffineTransform) scale.clone();

		return clone;
	}

	/***************************************************************************
	 * ̉
	 **************************************************************************/
	/**
	 * RXgN^B<br>
	 * `̈ɉ}`𐶐B<br>
	 * ӁF}`O[v̍WnB
	 * 
	 * @param x `̈x
	 * @param y `̈y
	 * @param width `̈width
	 * @param height `̈height
	 */
	public void initializedForSelectionBounds(int x, int y, int width,
			int height) {
		Rectangle selection = design.getSelection();

		// g嗦vZ
		double scaleX = (double) width / (double) selection.width;
		double scaleY = (double) height / (double) selection.height;

		// I͈͂ɍ킹Đ}`̎n_ݒ肷
		// Őݒ肵Ă̂͑I͈͂ɍ킹Đ}`g傷邱Ƃln_
		Point2D designBegin = design.getBegin();
		int beginX = (int) (x - selection.x * scaleX + designBegin.getX()
				* scaleX);// n_̈ʒuvZ
		int beginY = (int) (y - selection.y * scaleY + designBegin.getY()
				* scaleY);// n_̈ʒuvZ
		PicturePoint begin = new PicturePoint(new Point(beginX, beginY));

		// }`̉
		initializeForStandard(begin);

		// I͈͂ɉ킹Đ}`g
		this.scale.scale(scaleX, scaleY);

	}

	/**
	 * WTCYŋ̉
	 * 
	 * @param begin }`̎n_
	 */
	public void initializeForStandard(PicturePoint begin) {
		// }`w肳ꂽn_ɍ킹Ĉړ
		this.translate.translate(begin.getX(), begin.getY());

		// n_ݒ
		this.begin = begin;
		this.begin.addChild(this);

		// I_ݒ
		this.end = new PicturePoint(this.getTransform().transform(
				design.getEnd(), null));// ݌viK̓_̒iK̓_ɕϊ
		this.end.addParent(this);

		// _ݒ
		Point2D[] designControls = design.getControls();
		this.controls = new PicturePoint[designControls.length];
		for (int i = 0; i < designControls.length; i++) {
			this.controls[i] = new PicturePoint(this.getTransform().transform(
					designControls[i], null));
			this.controls[i].addParent(this);
		}

		// SĂ̕ҏW_Xgݒ
		allEditPoints.add(this.begin);
		allEditPoints.add(this.end);
		allEditPoints.addAll(Arrays.asList(this.controls));
	}

	public void setParentGroup(Group group) {
		if (group instanceof PictureGroup) {
			this.parentGroup = (PictureGroup) group;
		} else {
			throw new RuntimeException("}`ɐ}`O[vȊO̐eO[v͐ݒł܂");
		}
	}

	public Group getParentGroup() {
		return parentGroup;
	}

	/***************************************************************************
	 * }`
	 **************************************************************************/
	public void setLocation(int x, int y) {
		setLocation((double) x, (double) y);
	}

	/**
	 * w肳ꂽʒuɐݒ肷
	 */
	public void setLocation(double x, double y) {
		// if ( state == INSTANCE ) {
		double dx = x - (int) this.begin.getX();
		double dy = y - (int) this.begin.getY();
		translate(dx, dy);
	}

	/**
	 * ړ
	 */
	public void translate(double dx, double dy) {
		this.translate.translate((double) dx, (double) dy);
		// if (isInitialize) {
		repositionAllEditPoints();
		fireEdittingMoveForAllControlPoints();
		// }
	}

	/**
	 * g傷B<br>
	 * n_Œ肵Ċg傷BgɂĈړҏW_ɑ΂ĈړꂽʒmB
	 * 
	 * @param sx xg嗦
	 * @param sy yg嗦
	 */
	public void scale(double sx, double sy) {
		this.scale.scale(sx, sy);
		// if (isInitialize) {
		repositionAllEditPoints();

		fireEdittingMoveForAllControlPoints();// _ړʒm
		end.fireEdittingMove();// I_ҏWړʒm
		// }
	}

	/**
	 * ]<br>
	 * n_Œ肵ĉ]B]ɂĈړҏW_ɑ΂ĈړꂽʒmB
	 * 
	 * @param theta
	 */
	public void rotate(double theta) {
		this.rotate.rotate(theta);
		// if (isInitialize) {
		repositionAllEditPoints();

		fireEdittingMoveForAllControlPoints();// _ҏWړʒm
		end.fireEdittingMove();// I_ҏWړʒm
		// }
	}

	/**
	 * ۗLĂҏW_̈ʒuςƂɌĂяoB
	 * 
	 * @param point ړҏW_B TODO Ƃ܂Ƃ߂邾낤BɂBdĂ
	 */
	public void editPointMoved(PicturePoint point) {
		// // OƔׂēĂȂƂ͉Ȃ TODO ܈ӖȂ
		// if (point.equals(point.getOldPoint())) {
		// System.out.println(point.toString() + "͓ĂȂ");
		// return;
		// }

		// n_Ƃ
		// TODO n_I_ƓʒuɂȂƂɃoOBB
		if (point == begin) {
			System.out.println("begin moved");
			// XP[OƉ]ƈړsƉ߂

			// ړVϊW߂
			setScaleByBeginAndEnd();
			double angle = getAngleOfBeginEnd(); // 2_̉]x
			double translateX = this.begin.getX() - design.getBegin().getX();
			double translateY = this.begin.getY() - design.getBegin().getY();

			// ϊWXV
			// this.scale.setToScale(scaleX, scaleY); // xXP[OXVȂiL΂̂Łj
			this.rotate.setToRotation(angle);
			this.translate.setToTranslation(translateX, translateY);

			// ׂĂ̕ҏW_ό`Wɏ]čĔzu
			repositionAllEditPoints();

			// _ɓƂʒm
			fireEdittingMoveForAllControlPoints();

			// I_Ƃ
		} else if (point == end) {
			// XP[OƉ]sƉ߂
			System.out.println("end moved");
			// ړϊ߂

			// ݌viKł̈ړ߂

			// XP[OW߂
			setScaleByBeginAndEnd();

			// Βl̊gx
			double angle = getAngleOfBeginEnd(); // 2_̉]x

			// ϊWXV
			// double scaleY = this.scale.getScaleY();
			// this.scale.setToScale(scaleX, scaleY);
			this.rotate.setToRotation(angle);

			// ׂĂ̕ҏW_ό`Wɏ]čĔzu
			repositionAllEditPoints();

			// _ɓƂʒm
			fireEdittingMoveForAllControlPoints();

		} else {
			Point2D[] designControls = design.getControls();
			for (int i = 0; i < controls.length; i++) {
				// _Ƃ
				if (point == controls[i]) {
					System.out.println("contorols[" + i + "] moved");
					// ݌v}̕ύXƂ݂Ȃ
					// TODO ByXP[OƂ݂ȂB̂B

					// ݌viKł̈ړ߂
					Point2D pure = new Point.Double(); // g͈ӖȂiRpCG[j
					getToDesignPhaseTransform().transform(point, pure);

					// ݌viKł̃XP[Ox߂
					double scaleY = pure.getY() / designControls[i].getY();

					// ϊWXV
					// ݂̃XP[OxyXV
					double scaleX = this.scale.getScaleX();
					this.scale.setToScale(scaleX, scaleY);

					// ׂĂ̕ҏW_ό`Wɏ]čĔzu
					repositionAllEditPoints();

					// _Ƃ͑_ɓƂʒmKv͂ȂB

				}
			}
		}
	}

	/*
	 *  begin end ̐݌v}̊px߂B
	 */
	private double getAngleOfBeginEnd() {
		// Βl̊gx
		double angle = Math.atan2(end.getY() - begin.getY(), end.getX()
				- this.begin.getX());
		double designAngle = Math.atan2(design.getEnd().getY()
				- design.getBegin().getY(), design.getEnd().getX()
				- design.getBegin().getX()); // 2_̉]x
		return angle - designAngle;
	}

	/*
	 * n_ƏI_g嗦ݒ肷B
	 */
	private void setScaleByBeginAndEnd() {
		// ̊g嗦߂
		double horizontalScale = 1.0;
		double designBEDistance = design.getEnd().distance(design.getBegin());

		if (designBEDistance != 0) {
			horizontalScale = end.distance(begin) / designBEDistance;

		} else {
			horizontalScale = 1.0;
		}

		// g嗦ݒ肷
		scale.setToScale(horizontalScale, scale.getScaleY());
	}

	/**
	 * SĂ̑_ɑ΂A_ƂʒmB
	 */
	protected void fireEdittingMoveForAllControlPoints() {
		for (int i = 0; i < controls.length; i++) {
			controls[i].fireEdittingMove();
		}
	}

	/**
	 * 폜B<br>
	 * ̐}`폜ꂽƂʒmB
	 */
	public void kill() {
		// ۗLĂ_玩폜
		for (Iterator iter = allEditPoints.iterator(); iter.hasNext();) {
			((PicturePoint) iter.next()).removeHolder(this);
		}
	}

	/**
	 * 폜}`𕜊B<br>
	 * 
	 * TODO ςȃ\bhBȂƂȂȂ̂
	 */
	public void live() {
		// ۗLĂ_Ɏo^
		begin.addChild(this);
		end.addParent(this);
		for (int i = 0; i < controls.length; i++) {
			((PicturePoint) controls[i]).addParent(this);
		}
	}

	/**
	 * ݂̕ϊW߂B
	 * 
	 * @return ݂̕ϊWԂB
	 */
	protected AffineTransform getTransform() {
		AffineTransform transform = new AffineTransform();
		transform.concatenate(this.translate);
		transform.concatenate(this.rotate);
		transform.concatenate(this.scale);
		return transform;
	}

	/**
	 * ݂̕ό`WKpĂ̂ɑ΂A <br>
	 * ]ƈړ݌viKɖ߂ׂ̕ϊWԂB TODO ̈Ӗ킩˂ <br>
	 * 
	 * @return ]ƈړ݌viKɖ߂߂̕ϊWԂB
	 */
	protected AffineTransform getToDesignPhaseTransform() {
		// tϊ
		AffineTransform toDesignPhase = new AffineTransform();
		try {
			toDesignPhase.concatenate(this.rotate.createInverse());
			toDesignPhase.concatenate(this.translate.createInverse());

			// O
		} catch (NoninvertibleTransformException e) {
			System.out.println("\ʃG[");
			System.out.println(design.getName() + " ts񂪋߂܂");
			System.out.println(e.toString());
		}
		return toDesignPhase;
	}

	/*
	 * SĂ̕ҏW_݂̕ϊWɏ]čēxWw肷
	 */
	private void repositionAllEditPoints() {
		// USĂ̕ҏW_݌vʂɖ߂
		this.begin.setLocation(design.getBegin());
		this.end.setLocation(design.getEnd());
		Point2D[] designControls = design.getControls();
		for (int i = 0; i < controls.length; i++) {
			this.controls[i].setLocation(designControls[i]);
		}

		// ݂̕ϊWɏ]čēxWw
		// FIXME Ȃŏ肭Ă񂾁HbeginƂ͏㏑ĂCB
		// ̕@transform()ϊPoint2DVA
		// ύXĂŐ藧Ă@B
		Point2D[] all = (Point2D[]) allEditPoints
				.toArray(new Point2D[allEditPoints.size()]);
		this.getTransform().transform(all, 0, all, 0, all.length);
		allEditPoints.clear();
		allEditPoints.addAll(Arrays.asList(all));
	}

	/***************************************************************************
	 * toString
	 **************************************************************************/

	public String paramString() {
		return "name=" + design.getName() + ",begin=" + begin + ",end=" + end;
	}

	public String toString() {
		return getClass().getName() + "[" + paramString() + "]";
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	protected void setDesign(PictureDesign design) {
		this.design = design;
	}

	protected PictureDesign getDesign() {
		return this.design;
	}

	/**
	 * @return I_߂B
	 */
	public PicturePoint getEndPoint() {
		return end;
	}

	/**
	 * @return n_߂B
	 */
	public PicturePoint getBeginPoint() {
		return begin;
	}

	/**
	 * @return _ƏI_̃Xg߂B
	 */
	public List getChildPicturePointList() {
		List endAndControls = getPicturePointList();
		endAndControls.remove(begin);
		return endAndControls;
	}

	/**
	 * @param begin n_ݒ肷B
	 */
	public void setBeginPoint(PicturePoint begin) {
		// ݂̎n_ւ̓o^
		if (this.begin != null) {
			this.begin.removeHolder(this);
			allEditPoints.remove(this.begin);
		}

		// Vn_ݒ肷
		this.begin = begin;
		this.begin.addChild(this);
		allEditPoints.add(begin);
	}

	/**
	 * @return }`SĂ̕ҏW_̃Xg߂B
	 */
	public List getPicturePointList() {
		return new ArrayList(allEditPoints);
	}

	/**
	 * }`̌`ԂB <br>
	 * }`͕ۗLIuWFNg̊__Ƃ}`ŕԂB <br>
	 * 
	 * @return }` Shape ߂B
	 */
	public Shape getShape() {
		// GeneralPath path = getUninitializedShape();
		// path = (GeneralPath) path.clone();
		// }`ό`

		return getTransform().createTransformedShape(design.getShape());
	}

	/**
	 * @return }`̖O߂B
	 */
	public String getName() {
		return this.design.getName();
	}

	/**
	 * @param color color ݒ肷B
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/**
	 * @return color ߂B
	 */
	public Color getColor() {
		return color;
	}

	/**
	 * @return e}`iO̐}`j邩ǂB
	 */
	public boolean hasParent() {
		return begin.getParentPicture() != null;
	}

	/**
	 * @return e}`iO̐}`j߂B
	 */
	public Picture getParent() {
		return begin.getParentPicture();
	}

	/**
	 * @return q}`ihĂ}`jĂ邩B
	 */
	public boolean hasChild() {
		return !getChild().isEmpty();
	}

	/**
	 * @return q}`ihĂ}`jB߂B
	 */
	public List getChild() {
		Set children = new HashSet();

		// n_ȊOhĂ}`BW߂
		children.addAll(end.getChildPictures());
		for (int i = 0; i < controls.length; i++) {
			children.addAll(controls[i].getChildPictures());
		}

		// // SĂ̓_hĂ}`BW߂
		// for (Iterator i = allEditPoints.iterator(); i.hasNext();) {
		// PicturePoint point = (PicturePoint) i.next();
		// children.addAll(point.getChildPictures());
		// }
		//
		// // O
		// children.remove(this);

		return new ArrayList(children);
	}

	/**
	 * @return ҏW_܂ł邩
	 */
	public boolean contains(PicturePoint point) {
		return allEditPoints.contains(point);
	}

	/**
	 * Class Vector2D ႿƍxNgNXB2B
	 * 
	 * @author user
	 * @version $Id: Picture.java,v 1.3 2006/02/08 04:22:29 tajifu Exp $
	 */
	private class Vector2D extends Point2D.Double {

		public Vector2D(Point2D vector) {
			super(vector.getX(), vector.getY());
		}

		public Vector2D(double x, double y) {
			super(x, y);
		}

		public Vector2D(Point2D from, Point2D to) {
			super(to.getX() - from.getX(), to.getY() - from.getY());
		}

		public Vector2D plus(Vector2D v) {
			return new Vector2D(getX() + v.getX(), getY() + v.getY());
		}

		public Vector2D minus(Vector2D v) {
			return new Vector2D(getX() - v.getX(), getY() - v.getY());
		}

		public Vector2D multiple(double a) {
			return new Vector2D(getX() * 1, getY() * a);
		}

		public Vector2D divide(double a) {
			if (a == 0) {
				throw new RuntimeException("divide by zero");
			}
			return new Vector2D(getX() / a, getY() / a);
		}

		public double abs() {
			return distance(0, 0);
		}

		public Vector2D norm() {
			double abs = abs();
			if (abs != 0) {
				return new Vector2D(getX() / abs, getY() / abs);
			} else {
				return new Vector2D(0, 0);
			}
		}

		// 
		// O
		// cos

	}
}
