package note.model;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Set;

import note.control.Pen;
import note.model.picture.PicturePoint;
import note.viewer.PictureGroupPane;

/**
 * }`O[vB<br>
 * ͂ꂽ}`̃O[v\B<br>
 * 
 * ԂfocusPointiI_j(0,0)B TODO focus selected ƂPictureGroupPaneɈړB
 * 
 * @author camei
 * @version $Id: PictureGroup.java,v 1.16 2006/02/06 20:13:02 camei Exp $
 */
public class PictureGroup extends Group implements Transferable, Cloneable,
		Serializable {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;


	// DataFlavor
	public static final DataFlavor PICTURE_FLAVOR = new DataFlavor(
			PictureGroup.class, "picture");

	private static final int INFINITE_DISTANCE = 3000;// [_

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private List pictureList = new LinkedList();// ۗLĂ}`

	// <<o>>
	private List picturePointList = new LinkedList();// ۗLĂ}`̎SĂ̓_

	// xASYp
	private transient Shape shape;// O[vɊ܂܂}`Shape𓝍Shape
	private transient boolean isUpdated = false;// XVꂽ

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 */
	public PictureGroup(int x, int y) {
		super(x, y);
		// picturePointList.add(new PicturePoint(new Point()));
	}

	/***************************************************************************
	 * clone
	 **************************************************************************/
	/**
	 * ̐}`O[ṽfB[vRs[߂B<br>
	 * }`O[vɊ܂܂ĂȂ}`͊֘AĂfB[vRs[A֘A폜B
	 * 
	 * @return ̐}`O[ṽfB[vRs[߂B
	 */
	public Object clone() {
		PictureGroup clone = new PictureGroup(getX(), getY());

		// O[v̎ŏ̐}`̎n_̃Rs[A
		// ̎n_̎q}`HăRs[ i}`̓c[\Ȃ̂Łj

		// O[v̍ŏ̐}`B߂
		Set firsts = getFirsts(pictureList);// ꍇ̂Œ

		for (Iterator i = firsts.iterator(); i.hasNext();) {
			Picture first = (Picture) i.next();// ŏ̐}`

			// ŏ̐}`̎n_̃fB[vRs[
			PicturePoint begin = first.getBeginPoint();
			PicturePoint cloneBegin = (PicturePoint) begin.clone();
			clonePicture(clone, begin, cloneBegin);
		}

		// }`_XV
		clone.updatePicturePoints();

		return clone;
	}

	/*
	 * }`_hĂ}`Rs[B<br> }`XgȊO̐}`̓Rs[ȂB
	 */
	private void clonePicture(PictureGroup clone, PicturePoint begin,
			PicturePoint cloneBegin) {

		Collection childPictures = begin.getChildPictures();// hĂ}`B
		for (Iterator j = childPictures.iterator(); j.hasNext();) {
			Picture picture = (Picture) j.next();// hĂ}`

			if (pictureList.contains(picture)) {// }`Xgɂ}`̏ꍇ

				// hĂ}`Rs[
				Picture clonePicture = (Picture) picture.clone();
				clonePicture.setBeginPoint(cloneBegin);
				clone.pictureList.add(clonePicture);// ̐}`Xgɒǉ

				// hĂ}`hĂ}`Rs[
				List childPoints = picture.getChildPicturePointList();
				List cloneChildPoints = clonePicture.getChildPicturePointList();
				for (int i = 0; i < childPoints.size(); i++) {
					clonePicture(clone, (PicturePoint) childPoints.get(i),
							(PicturePoint) cloneChildPoints.get(i));
				}
			}
		}
	}

	/***************************************************************************
	 * }`͊֘A
	 **************************************************************************/
	/**
	 * O[vɐ}`O[vǉiAjB TODO O[v͂߂CompundPictuređ}ւB
	 * 
	 * @param pictureGroup
	 */
	public void addPictureGroup(PictureGroup pictureGroup) {
		PicturePoint focusPoint = ((PictureGroupPane) getEditor())
				.getFocusPoint();

		// ǉ}`BI_Ɉړ
		int x = (int) focusPoint.getX();
		int y = (int) focusPoint.getY();
		translatePictures(pictureGroup.pictureList, x, y);

		// I_Ɛ}`O[v̎n_A
		PicturePoint begin = getBegin(pictureGroup.pictureList);
		Collection beginPictures = begin.getChildPictures();
		for (Iterator i = beginPictures.iterator(); i.hasNext();) {
			Picture beginPicture = (Picture) i.next();
			beginPicture.setBeginPoint(focusPoint);
		}
		pictureGroup.updatePicturePoints();

		// ǉ}`O[vɊ܂܂}`ׂĒǉ
		pictureList.addAll(pictureGroup.pictureList);
		picturePointList.addAll(pictureGroup.picturePointList);

		isUpdated = true;// XVꂽԂɂ
	}

	/**
	 * }`ǉB
	 * 
	 * @param picture ǉ}`
	 */
	public void addPicture(Picture picture) {

		// }`Xgɒǉ
		pictureList.add(picture);

		// }`̕ҏW_ҏW_Xgǉ
		picturePointList.addAll(picture.getPicturePointList());

		isUpdated = true;// XVꂽԂɂ
	}

	/**
	 * }`Bǉ
	 * 
	 * @param pictures ǉ}`Collection
	 */
	public void addAllPicture(Collection pictures) {
		pictureList.addAll(pictures);
		updatePicturePoints();
	}

	/***************************************************************************
	 * }`ό`֘A
	 **************************************************************************/

	/**
	 * }`_ړĐ}`ό`B<br>
	 * ړ̓O[vWnŎw肷邱ƁB<br>
	 * 
	 * @param picturePoint ړ}`_
	 * @param x ړx
	 * @param y ړy
	 */
	public void edittingMoveFocusPoint(PicturePoint picturePoint, int x, int y) {
		if (picturePointList.contains(picturePoint)) {
			// }`_ړ
			picturePoint.setLocation(x, y);

			// ړꂽƂʒm
			picturePoint.fireEdittingMove();

			isUpdated = true;// XVꂽԂɂ
		}
	}

	/**
	 * I͈͂߂B<br>
	 * 
	 * @return IĂ}`Bō\}`O[v߂B
	 */
	public PictureGroup getSelection() {
		List selectedPictureSet = ((PictureGroupPane) getEditor())
				.getSelectedPictureList();

		PictureGroup selection;

		{// I͈͂\}`O[v
			// I͈͂̎n__Ƃ}`O[v
			PicturePoint begin = getBegin(selectedPictureSet);
			int x = (int) begin.getX();
			int y = (int) begin.getY();
			selection = new PictureGroup(x, y);

			// }`O[vɑI͈͂̐}`Bǉ
			selection.pictureList.addAll(selectedPictureSet);

			// fB[vRs[쐬
			selection = (PictureGroup) selection.clone();

			// I͈͂̎n__ɂȂ悤ɑSĂ̐}`ړ
			translatePictures(selection.pictureList, -x, -y);
		}

		return selection;
	}

	/***************************************************************************
	 * Group ̎ & I[o[Ch
	 **************************************************************************/

	public Rectangle getBounds() {
		Rectangle bounds = getShape().getBounds();
		bounds.translate(getX(), getY());
		return bounds;
	}

	public boolean contains(int x, int y) {
		return getBounds().contains(x, y);
	}

	public boolean intersects(int x, int y, int width, int height) {
		return getBounds().intersects(x, y, width, height);
	}

	/***************************************************************************
	 * 폜֘A
	 **************************************************************************/
	/**
	 * O[v}`폜B
	 */
	public void remove(Picture picture) {
		// }`폜
		pictureList.remove(picture);
		picture.kill();

		// ҏW_XgXV
		updatePicturePoints();
	}

	/**
	 * O[v}`B폜B
	 */
	public void removeAll(Collection pictures) {
		// }`폜
		pictureList.removeAll(pictures);
		for (Iterator iter = pictures.iterator(); iter.hasNext();) {
			((Picture) iter.next()).kill();
		}

		// ҏW_XgXV
		updatePicturePoints();
	}

	/***************************************************************************
	 * ėp\bh
	 **************************************************************************/
	/*
	 * }`BړB<br> O[v̈ړƂ͈Ⴄ̂ŒӁB}`̓O[v̍Wnŕ\ĂÃ\bh͐}`̃T\ړB
	 */
	private void translatePictures(Collection pictures, double dx, double dy) {
		for (Iterator i = pictures.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();
			picture.translate(dx, dy);
		}
	}

	/*
	 * I͈͂hĂq}`B߂B
	 */
	// private Set getSelectionChildPictureSet() {
	// Set children = new HashSet();
	//
	// // I͈͂hĂ}`BW߂
	// for (Iterator i = selectedPictureSet.iterator(); i.hasNext();) {
	// Picture picture = (Picture) i.next();
	// children.addAll(picture.getChild());
	// }
	//
	// // I͈͂O
	// children.removeAll(selectedPictureSet);
	//
	// return children;
	// }
	/*
	 * }`B̍ŐeB߂BPictureNXCollectionw肷邱ƁB
	 */
	private Set getFirsts(Collection pictures) {
		// Ƃ̐e߂
		Set firsts = new HashSet();
		for (Iterator i = pictures.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();

			// }`OHāAŏ̐}`
			Picture first = picture;
			while (true) {
				if (first.hasParent() && pictures.contains(first.getParent())) {// w肳ꂽWőO̐}`ꍇ
					first = first.getParent();
					continue;
				} else {
					break;
				}
			}

			// ŏ̐}`ۑ
			firsts.add(first);
		}

		return firsts;
	}

	/*
	 * }`B̍Ŏn_߂B
	 */
	private PicturePoint getBegin(Collection pictures) {
		// 擪̐}`߂
		Set firsts = getFirsts(pictures);

		// Ƃ̎n_߂
		PicturePoint[] begins = new PicturePoint[firsts.size()];
		int i = 0;
		for (Iterator iter = firsts.iterator(); iter.hasNext();) {
			begins[i] = ((Picture) iter.next()).getBeginPoint();
			i++;
		}

		// Ŝ̎n_߂
		PicturePoint begin = null;
		if (begins.length > 1) {// Ƃ̎n_ꍇ
			// łɂ̂n_Ƃ
			double minX = INFINITE_DISTANCE;
			for (int j = 0; j < begins.length; j++) {
				if (begins[j].getX() < minX) {
					minX = begins[j].getX();
					begin = begins[j];
				}
			}

		} else if (begins.length == 1) {// Ƃ̎n_1݂̂̏ꍇ
			begin = begins[0];

		} else {// G[
			throw new Error("O[v̎n_߂܂");
		}

		return begin;
	}

	/*
	 * O[v̐}`̕ҏW_XgXV
	 */
	private void updatePicturePoints() {
		// Xg
		picturePointList.clear();

		// XgɑSĂ̐}`̕ҏW_ǉ
		for (int i = 0; i < pictureList.size(); i++) {
			List points = ((Picture) pictureList.get(i)).getPicturePointList();
			picturePointList.addAll(points);
		}
	}

	/***************************************************************************
	 * Transferable iNbv{[h]f[^j̎
	 **************************************************************************/
	/**
	 * @return
	 */
	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[] { PICTURE_FLAVOR };
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return flavor.equals(PICTURE_FLAVOR);
	}

	public Object getTransferData(DataFlavor flavor)
			throws UnsupportedFlavorException, IOException {
		return this.clone();
	}

	/***************************************************************************
	 * toString
	 **************************************************************************/

	public String toString() {
		return getClass().getName() + "[}`=" + pictureList.size() + "]";
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	/**
	 * @return O[vSĂ̐}`߂B
	 */
	public List getPictureList() {
		return new ArrayList(pictureList);
	}

	/**
	 * @param picture }`
	 * @return O[vɎw肳ꂽ}`܂܂Ă邩
	 */
	public boolean containsPicture(Picture picture) {
		return pictureList.contains(picture);
	}

	/**
	 * @return O[vSĂ̕ҏW_߂B
	 */
	public List getPicturePointList() {
		return new ArrayList(picturePointList);
	}

	/**
	 * @param picturePoint }`_
	 * @return O[vɐ}`_܂܂Ă邩
	 */
	public boolean containsPicturePoint(PicturePoint picturePoint) {
		return picturePointList.contains(picturePoint);
	}

	/**
	 * @return I_߂B<br>
	 * ҏWԂłȂꍇ<code>null</code>߂B
	 */
	public PicturePoint getFocusPoint() {
		return ((PictureGroupPane) getEditor()).getFocusPoint();
	}

	/**
	 * @return O[vSĂ̐}`𓝍ShapeIuWFNg߂B
	 */
	public Shape getShape() {
		if (shape == null || isUpdated) {// XVꂽꍇ
			// O[vShapeXV
			GeneralPath newShape = new GeneralPath();
			for (Iterator i = pictureList.iterator(); i.hasNext();) {
				Picture picture = (Picture) i.next();
				newShape.append(picture.getShape(), false);
			}
			this.shape = newShape;
		}

		return this.shape;
	}

	/**
	 * @return I͈͂邩 TODO B
	 */
	public boolean hasSelection() {
		return ((PictureGroupPane) getEditor()).hasSelection();
	}

	/**
	 * @return selectedPictureList ߂B
	 */
	public List getSelectedPictureList() {
		return ((PictureGroupPane) getEditor()).getSelectedPictureList();
	}

	public boolean isEmpty() {
		return pictureList.isEmpty();
	}

	/**
	 * I_ݒ肷B
	 * 
	 * @param focusPoint I_
	 */
	public void setFocusPoint(PicturePoint focusPoint) {
		if (picturePointList.contains(focusPoint)) {
			((PictureGroupPane) getEditor()).setFocusPoint(focusPoint);
		} else {
			throw new RuntimeException("I_̎w肪sł");
		}
	}

	// \bh낤B

	/**
	 * w肵͈͂Ɋ܂܂}`߂B
	 * 
	 * @param area
	 * @return
	 */
	public List getContainedElementsByBounds(Rectangle area) {
		List pictures = new ArrayList();
		int x = (int) area.getX() - getX();
		int y = (int) area.getY() - getY();
		int width = (int) area.getWidth();
		int height = (int) area.getHeight();
		for (Iterator i = pictureList.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();
			if (picture.getShape().contains(x, y, width, height)) {
				pictures.add(picture);
			}
		}

		return pictures;
	}

	/**
	 * w肵_܂picture߂B
	 * 
	 * @param x
	 * @param y
	 * @return
	 */
	public Picture getContainedElementsByPoint(int x, int y) {
		int x2 = x - getX();
		int y2 = y - getY();
		for (Iterator i = pictureList.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();
			if (picture.getShape().contains(x2, y2)) {
				return picture;
			}
		}
		return null;
	}

}
