/*
 * m[g̕ҏWyC
 * NoteProcessorPane.java
 */
package note.viewer;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.HashMap;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.border.BevelBorder;
import javax.swing.undo.UndoManager;

import note.NoteApplication;
import note.configuration.ApplicationConfiguration;
import note.control.Pen;
import note.model.Note;
import note.model.NoteStyle;
import note.model.Page;

/**
 * ̂Ƃ̕ҏWyCB<br>
 * y[WyC܂ރyCB<br>
 * 
 * @author camei
 * @version $Id: NoteProcessorPane.java,v 1.24 2006/02/07 13:25:52 hashiyaman Exp $
 */
public class NoteProcessorPane extends JPanel {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	private static final String DEFAULT_FILE_NAME = "Vt@C";

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private Note note;
	private PagePane currentPagePane;// ݕ\Ăy[WyC
	private ApplicationConfiguration configuration;
	private UndoManager undoManager = new UndoManager();// UNDOǗ@\

	private HashMap pagePanes = new HashMap();// y[WyC
	private JTextArea pageNumberTextArea;// y[W\eLXgGA

	// Cxg֘A
	private NoteApplication listener;// Cxgnh
	
	//
	private String fileName = null;// t@C
	private boolean isDirty = false;// ۑɕύXǂ

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B
	 * 
	 * @param note m[g
	 * @param currentPen ݂̃y
	 * @param listener NoteApplication
	 */
	public NoteProcessorPane(Note note, ApplicationConfiguration configuration, NoteApplication listener) {
		super();
		this.note = note;
		this.configuration = configuration;
		this.listener = listener;
		
		this.note.addNoteChangedListener(this);
		
		// t@C
		setFileName(DEFAULT_FILE_NAME);

		// GUI
		setLayout(new BorderLayout());
		
//		{// y[WTlCyC̃eXg
//			JPanel panel = new JPanel();
//			JLabel label = new JLabel("\ny[W\nTlC\nyC");
//			panel.add(label);
//			add(panel, BorderLayout.WEST);
//		}
		
		{// y[W\ĩ݂y[W^y[Wj
			JPanel panel = new JPanel();
			pageNumberTextArea = new JTextArea(note.getCurrentPageIndex() + 1
					+ " / " + note.getNumberOfTotalPages());
			pageNumberTextArea.setBorder(new BevelBorder(BevelBorder.LOWERED));// ڂ݃{[_[ݒ
			pageNumberTextArea.setEditable(false);
			pageNumberTextArea.setFocusable(false);// tH[JX擾Ȃ
			panel.add(pageNumberTextArea);
			add(panel, BorderLayout.SOUTH);
		}

		setRequestFocusEnabled(false);

		// \y[Wݒ肷
		setCurrentPage(note.getCurrentPage());
	}

	/*
	 * V PagePane 𐶐B
	 */
	private PagePane createPagePane(NoteStyle noteStyle, Page page) {
		// w肳ꂽy[W\yC𐶐
		PagePane pane = new PagePane(page, noteStyle, configuration, listener);

		// y[WƂ\yC֘At
		String pageKey = getPageKey(page);
		pagePanes.put(pageKey, pane);

		// y[W̃CxgXi[o^
		Component viewer = pane.getViewer();
		// viewer.addKeyListener(keyListener);
		// viewer.addMouseListener(mouseListener);
		viewer.addKeyListener(listener);
		viewer.addMouseListener(listener);
		viewer.addMouseMotionListener(listener);

		// yC߂
		return pane;
	}

	/*
	 * w肳ꂽy[W\yC߂B
	 */
	private PagePane getPagePane(Page page) {

		// Ɏw肳ꂽy[W\yC邩ǂׂ
		String pageKey = getPageKey(page);// y[WӂɌ߂L[
		if (pagePanes.containsKey(pageKey)) {// yCꍇ
			// y[W\yC߂
			return (PagePane) pagePanes.get(pageKey);

		} else {// yCꍇ
			// VyC𐶐Ao^Ė߂
			return createPagePane(note.getNoteStyle(), page);
		}
	}

	/*
	 * y[WӂɌ߂L[߂B
	 */
	private String getPageKey(Page page) {
		int hashCode = page.hashCode();
		return Integer.toString(hashCode);
	}

	/*
	 * \y[Wݒ肷B
	 */
	private void setCurrentPage(Page page) {
		PagePane pagePane = getPagePane(page);// y[W\yC

		if (currentPagePane != pagePane) {
			// ݕ\Ăy[WyCO
			if (currentPagePane != null) {// ݕ\Ăy[WyCꍇ
				remove(currentPagePane);
			}

			// ݕ\Ăy[WyCXV
			this.currentPagePane = pagePane;
			add(currentPagePane, BorderLayout.CENTER);
			validate();// ăCAEgiPagePaneK؂ȃTCYɂj

			// yCɃtH[JXĂ
			currentPagePane.getViewer().requestFocus();

			// ĕ`悷
			repaint();
		}
	}

	/***************************************************************************
	 * Cxg
	 **************************************************************************/
	/**
	 * y[WXVƂɌĂяo郁\bhB
	 */
	public void updatePage() {
		// \y[W݂̃y[Wɐݒ肷
		setCurrentPage(note.getCurrentPage());
		
		// y[WXV		
		pageNumberTextArea.setText(note.getCurrentPageIndex() 
			+ 1 + " / " + note.getNumberOfTotalPages());
		
		// y[WɃtH[JXڂ
		currentPagePane.getViewer().requestFocus();
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return currentPagePane ߂܂B
	 */
	public PagePane getCurrentPagePane() {
		return currentPagePane;
	}

	/**
	 * @return undoManager ߂܂
	 */
	public UndoManager getUndoManager() {
		return undoManager;
	}

	/**
	 * @return isDirty ߂܂
	 */
	public boolean isDirty() {
		return isDirty;
	}

	/**
	 * @param isDirty ۑɍXVǂ
	 */
	public void setDirty(boolean isDirty) {
		this.isDirty = isDirty;
	}
	
	/**
	 * @return t@C邩ǂ߂܂
	 */
	public boolean hasFileName() {
		return !fileName.equals(DEFAULT_FILE_NAME + " - " + NoteApplication.VERSION);
	}
	
	/**
	 * @return t@C߂܂
	 */
	public String getFileName() {
		return fileName;
	}
	
	/**
	 * @param filename t@C܂
	 */
	public void setFileName(String filename) {
		this.fileName = filename + " - " + NoteApplication.VERSION;
	}
}
