/**
 * 
 */
package note.command;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoableEdit;

import note.NoteApplication;

/**
 * }NR}hB<br>
 * ̃R}hԂɎsR}hB
 * 
 * @author camei
 * @version $Id: MacroCommand.java,v 1.3 2006/01/05 09:01:23 camei Exp $
 */
public class MacroCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private List commandList = new ArrayList();// R}hXg
	private String name = "}N";// }NR}h̖O

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B
	 * 
	 * @param reciever V[o[
	 */
	public MacroCommand(NoteApplication reciever) {
		super(reciever);
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		MacroCommand clone = new MacroCommand(getApplication());
		for (Iterator i = commandList.iterator(); i.hasNext();) {
			AbstractCommand command = (AbstractCommand) i.next();
			clone.commandList.add((AbstractCommand) command.clone());
		}
		return clone;
	}

	/**
	 * @return ݎs\ǂ
	 * @see note.command.AbstractCommand#isEnabled()
	 */
	public boolean canExecute() {
		// SẴR}hs\ȏꍇAL
		// TODO {ɂHsłȂ̂Ă񂶂Ȃ̂Hexecutêقŕ򂷂΁B
		for (int i = 0; i < commandList.size(); i++) {
			if (!((AbstractCommand) commandList.get(i)).canExecute()) {
				return false;
			}
		}
		return true;
	}

	/**
	 * sB
	 * 
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		super.execute();
		
		// R}hԂɎs
		AbstractCommand command;
		for (int i = 0; i < commandList.size(); i++) {
			command = (AbstractCommand) commandList.get(i);
			command.execute();
		}
	}

	/**
	 * R}hǉB
	 * 
	 * @param command ǉR}h
	 */
	public void add(AbstractCommand command) {
		commandList.add(command);
	}

	/**
	 * R}h폜B
	 * 
	 * @param command 폜R}h
	 */
	public void remove(AbstractCommand command) {
		commandList.remove(command);
	}

	/*
	 * @see note.command.AbstractCommand#paramString()
	 */
	protected String paramString() {
		StringBuffer param = new StringBuffer();
		for (int i = 0; i < commandList.size(); i++) {
			AbstractCommand command = (AbstractCommand) commandList.get(i);
			param.append(i + "=" + command.toString() + ",");
		}
		return param.toString();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// R}hB̂Aǂꂩ1\Ȃ\
		boolean isUndoable = false;
		for (int i = 0; i < commandList.size(); i++) {
			AbstractCommand command = (AbstractCommand) commandList.get(i);
			if (command.isUndoableEdit()) {
				isUndoable = true;
			}
		}
		return isUndoable;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return name;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getRedoPresentationName()
	 */
	public String getRedoPresentationName() {
		return name;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getUndoPresentationName()
	 */
	public String getUndoPresentationName() {
		return name;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		// SẴR}htUndo
		for (int i = commandList.size() - 1; i >= 0; i--) {
			UndoableEdit command = (UndoableEdit) commandList.get(i);
			command.undo();
		}
	}

	/***************************************************************************
	 * Setter & Getter
	 **************************************************************************/
	/**
	 * R}h̖Oݒ肷B
	 * 
	 * @param name R}h̖O
	 */
	public void setName(String name) {
		this.name = name;
	}
}
