/*
 * Created on Jun 30, 2005
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.control;

import note.model.Group;
import note.model.PictureGroup;
import note.model.TextGroup;

import java.io.Serializable;

/**
 * Class NoteApplicationMode<br>
 * y[W̕ҏWԁB<br>
 * 
 * TODO ړL[Ă邩ǂ̓y[W̕ҏWԂł͂ȂAcontrolmodelȂ̂ŁAȂƂB
 * 
 * @author lynnmac
 * @version $Id: NoteApplicationMode.java,v 1.1 2005/11/18 16:59:05 hashiyaman
 * Exp $
 */
public class NoteApplicationMode implements Cloneable, Serializable {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	// [h
	/** }`̓[h */
	public static final int PICTURE_MODE = 1;
	/** eLXg̓[h */
	public static final int TEXT_MODE = 2;
	/** O[vҏW[h */
	public static final int GROUP_MODE = 3;

	// }`̓[hƃeLXg̓[h̏
	/** ͑҂ */
	public static final int WAIT_INPUT = 1;
	/** ͒ */
	public static final int INPUT = 2;// 

	// ړL[̏
	// TODO ȂB
	private static final int PRESSED = 1;
	private static final int RELEASED = 2;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int mode = TEXT_MODE;// [h
	private int state = WAIT_INPUT;// 
	private int anchorMoveKeyState = RELEASED;
	private boolean isGroupEditMode = false;// O[vҏW[hǂ

	/***************************************************************************
	 * \bh
	 **************************************************************************/

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		NoteApplicationMode clone = new NoteApplicationMode();
		clone.mode = this.mode;
		clone.state = this.state;
		clone.anchorMoveKeyState = this.anchorMoveKeyState;
		return clone;
	}

	/**
	 * [h̕\߂B
	 * 
	 * @param mode [h
	 * @return [h̕\
	 */
	public static String getModeText(int mode) {
		if (mode == TEXT_MODE) {
			return "eLXg̓[h";
		} else if (mode == PICTURE_MODE) {
			return "}`̓[h";
		} else if (mode == GROUP_MODE) {
			return "O[vҏW[h";
		} else {
			return "";
		}
	}

	/**
	 * Ԃ̕\߂B
	 * 
	 * @param state 
	 * @return Ԃ̕\
	 */
	public static String getStateText(int state) {
		if (state == WAIT_INPUT) {
			return "͑҂";
		} else if (state == INPUT) {
			return "͒";
		} else {
			return "";
		}
	}

	/**
	 * @return \Ԃ
	 */
	public String toString() {
		StringBuffer state = new StringBuffer(getClass().getName() + "[mode=");
		if (mode == TEXT_MODE) {
			state.append("TEXT_MODE");
		} else if (mode == PICTURE_MODE) {
			state.append("PICTURE_MODE");
		} else if (mode == GROUP_MODE) {
			state.append("GROUP_MODE");
		}

		state.append(",state=");
		if (this.state == WAIT_INPUT) {
			state.append("WAIT_INPUT");

		} else if (this.state == INPUT) {
			state.append("INPUT");

		} else {
			state.append("");
		}

		state.append(",anchorMoveKey=");
		if (anchorMoveKeyState == PRESSED) {
			state.append("PRESSED");
		} else if (anchorMoveKeyState == RELEASED) {
			state.append("RELEASED");
		}

		state.append("]");
		return state.toString();
	}

	/**
	 * @return p[^\߂B
	 */
	public String paramString() {
		StringBuffer stateText = new StringBuffer();
		stateText.append(getModeText(mode) + ":" + getStateText(state) + ",");

		if (anchorMoveKeyState == PRESSED) {
			stateText.append("PRESSED");
		} else if (anchorMoveKeyState == RELEASED) {
			stateText.append("RELEASED");
		}

		return stateText.toString();
	}

	/***************************************************************************
	 * Cxgʒm
	 **************************************************************************/

	/**
	 * [hύXʒmB
	 * 
	 * @param mode ύX郂[h
	 */
	public void modeChanged(final int mode) {
		// tB[hBĂ̂Œ

		if (mode == TEXT_MODE) {
			if (this.mode != TEXT_MODE) {
				if (state == WAIT_INPUT || state == INPUT) {
					this.mode = TEXT_MODE;
					state = WAIT_INPUT;
				}
			}
		} else if (mode == PICTURE_MODE) {
			if (this.mode != PICTURE_MODE) {
				if (state == WAIT_INPUT || state == INPUT) {
					this.mode = PICTURE_MODE;
					state = WAIT_INPUT;
				}
			}
		} else if (mode == GROUP_MODE) {
			if (this.mode != GROUP_MODE) {
				this.mode = GROUP_MODE;
			}
		}
	}

	/**
	 * ړL[ꂽƂʒmB
	 */
	public void anchorMoveKeyPressed() {
		anchorMoveKeyState = PRESSED;
	}

	/**
	 * ړL[ꂽƂʒmB
	 */
	public void anchorMoveKeyReleased() {
		anchorMoveKeyState = RELEASED;
	}

	/**
	 * AJ[ړʒmB
	 * 
	 */
	public void anchorMoved() {
		if (mode == TEXT_MODE) {
			if (state == INPUT) {
				state = WAIT_INPUT;
			}
		}
	}

	/**
	 * O[vXVʒmB
	 * 
	 * @param group XVꂽO[v
	 */
	public void groupUpdated(Group group) {
		if (mode == PICTURE_MODE && group instanceof PictureGroup) {
			if (state == WAIT_INPUT) {
				if (!group.isEmpty()) {
					state = INPUT;
				}
			} else if (state == INPUT) {
				if (group.isEmpty()) {
					state = WAIT_INPUT;
				}
			}
		} else if (mode == TEXT_MODE && group instanceof TextGroup) {
			if (state == WAIT_INPUT) {
				if (!group.isEmpty()) {
					state = INPUT;
				}
			} else if (state == INPUT) {
				if (group.isEmpty()) {
					state = WAIT_INPUT;
				}
			}
		}
	}

	/**
	 * O[vҏWԂɂȂƂʒmB
	 * 
	 * @param group ҏWԂύXꂽO[v
	 */
	public void groupSetEditable(Group group) {
		if (group instanceof TextGroup) {
			modeChanged(TEXT_MODE);
		} else if (group instanceof PictureGroup) {
			modeChanged(PICTURE_MODE);
		}
		groupUpdated(group);
	}

	/**
	 * O[vmʒmB
	 */
	public void groupFixed() {
		if (mode == PICTURE_MODE) {
			if (state == INPUT) {
				state = WAIT_INPUT;
			}
		} else if (mode == TEXT_MODE) {
			if (state == INPUT) {
				state = WAIT_INPUT;
			}
		}
	}

	/**
	 * ҏW̃O[v폜ꂽƂʒm
	 */
	public void eitableGroupRemoved() {
		if (mode == PICTURE_MODE) {
			if (state == INPUT) {
				state = WAIT_INPUT;
			}
		} else if (mode == TEXT_MODE) {
			if (state == INPUT) {
				state = WAIT_INPUT;
			}
		}
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	/**
	 * p[^ݒ肷B
	 * 
	 * @param mode [h
	 */
	public void setValue(NoteApplicationMode mode) {
		this.mode = mode.mode;
		this.state = mode.state;
	}

	/**
	 * @return }`̓[hǂB
	 */
	public boolean isPictureMode() {
		return mode == PICTURE_MODE;
	}

	/**
	 * @return eLXg̓[hǂB
	 */
	public boolean isTextMode() {
		return mode == TEXT_MODE;
	}
	/**
	 * @return O[vҏW[h
	 */
	public boolean isGroupEditMode() {
		return mode == GROUP_MODE;
	}
	/**
	 * @return [h
	 */
	public int getMode() {
		return mode;
	}

	/**
	 * @return ͒ǂB
	 */
	public boolean isInputting() {
		return state == INPUT && (mode == TEXT_MODE || mode == PICTURE_MODE);
	}

	/**
	 * @return ͑҂ǂB
	 */
	public boolean isWaitInputting() {
		return state == WAIT_INPUT
				&& (mode == TEXT_MODE || mode == PICTURE_MODE);
	}

	/**
	 * @return ړCL[Ă邩ǂ
	 */
	public boolean isAnchorMoveKeyPressed() {
		return anchorMoveKeyState == PRESSED;
	}

	/**
	 * @return ړCL[Ă邩ǂ
	 */
	public boolean isAnchorMoveKeyReleased() {
		return anchorMoveKeyState == RELEASED;
	}

	/**
	 * TODO ̃\bh͏璷Ȃ
	 * 
	 * @return }`ό`ǂB
	 */
	public boolean isEdittingMoving() {
		return anchorMoveKeyState == PRESSED && mode == PICTURE_MODE
				&& state == INPUT;
	}

	/**
	 * O[vҏW[hǂݒ肷B
	 * 
	 * @param isGroupEditMode O[vҏW[h
	 * @return
	 */
//	public void setGroupEditMode(boolean isGroupEditMode) {
//		this.isGroupEditMode = isGroupEditMode;
//	}

}
